'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbcloud.exe"
#Dim All
#Include "Win32API.inc"
#Include "WinINET.inc"
#Include "CommCtrl.inc"
#Resource Icon, aaa, "files\cloud.ico"
#Resource Icon, xCreate, "files\create.ico"
#Resource Icon, xFonts, "files\text.ico"
#Resource Icon, xHelp, "files\help.ico"
#Resource Icon, xSize, "files\width.ico"
#Resource Icon, xColors, "files\colors.ico"
#Resource Icon, xView, "files\view.ico"
#Resource Icon, xSettings, "files\settings.ico"
#Resource Icon, xSave, "files\save.ico"
#Resource Icon, xOpen, "files\open.ico"
#Resource Icon, xNew, "files\new.ico"
#Resource Icon, xWords, "files\words.ico"
#Resource Icon, xImage, "files\image.ico"
#Resource Icon, xPatterns, "files\patterns.ico"
#Resource Icon, xLock, "files\lock.ico"

Type CWord
    text As String * 260
    target As String * 260
    freq As Long    ' 0 to 100 %
    rgb As Long     'color
    rc As Rect
    fontSize As Long
    rot As Long
    vis As Long
    tmdescent As Long
    manualRGB As Long
    res01 As Long
    res02 As Long
End Type

Type CFNData
   CFNimage As String * 260
   CharList As String * 260
   FontName As String * 260
   SymbolName As String * 260
   Res01 As String * 260
   Res02 As String * 260
   LowestAllowedFrequency As Long
   HideBadWords As Long
   FontItalic As Long
   FontBold As Long
   ColorHi As Long
   ColorLo As Long
   ColorBG As Long
   MinWordWidth As Long
   MaxWordsToDisplay As Long
   Rotation As Long
   ShowFrequency As Long
   FontSizeMin As Long
   FontSizeMax As Long
   MaxFreq As Long
   MinFreq As Long
   FreqRange As Long
   UseBGImage As Long
   MaxCWords As Long
   GrayScale As Long
   ThemeColor As Long
   WordMarginH As Long
   WordMarginV As Long
   DrawBoundary As Long
   ColorList As Long
   Patterns As Long
   EdgeMargin As Long
   Baseline As Long
   UseSymbolAsBG As Long
   WordsInSource As Long
   UniqueWordsInSource As Long
   VisibleWords As Long
   MaskColor As Long
   FastRemoval As Long
   FixedFont As Long
   FixedFontSize As Long
   FixedColor As Long
   AutoSpace As Long
   Lock As Long
   Res03 As Long
   Res04 As Long
   Res05 As Long
   Res06 As Long
   Res07 As Long
   Res08 As Long
   Colors(10) As Long
   CWords(1000) As CWord
End Type

Type CustomColors
   c(15) As Long
End Type

Type GdiplusStartupInput Dword
   GdiplusVersion           As Dword
   DebugEventCallback       As Dword
   SuppressBackgroundThread As Long
   SuppressExternalCodecs   As Long
End Type

Type GdiplusStartupOutput Dword
   NotificationHook   As Dword
   NotificationUnhook As Dword
End Type

Declare Function GdiplusStartup Lib "gdiplus.dll" Alias "GdiplusStartup" (ByRef token As Dword, ByRef Input As GdiplusStartupInput, ByRef Output As GdiplusStartupOutput) As Long
Declare Sub      GdiplusShutdown Lib "gdiplus.dll" Alias "GdiplusShutdown" (ByVal token As Dword)
Declare Function GdipGetImageWidth Lib "GDIPLUS.DLL" Alias "GdipGetImageWidth" (ByVal Image As Dword, ByRef Width As Dword) As Long
Declare Function GdipGetImageHeight Lib "GDIPLUS.DLL" Alias "GdipGetImageHeight" (ByVal Image As Dword, ByRef height As Dword) As Long
Declare Function GdipCreateFromHDC Lib "gdiplus.dll" Alias "GdipCreateFromHDC" (ByVal hdc As Dword, ByRef graphics As Dword) As Long
Declare Function GdipLoadImageFromFile Lib "gdiplus.dll" Alias "GdipLoadImageFromFile" (ByVal filename As Dword, ByRef Image As Dword) As Long
Declare Function GdipDrawImage Lib "gdiplus.dll" Alias "GdipDrawImage"(ByVal graphics As Dword, ByVal Image As Dword, ByVal x As Single, ByVal y As Single) As Long                                              ' GpStatus
Declare Function GdipDisposeImage Lib "gdiplus.dll" Alias "GdipDisposeImage" (ByVal Image As Dword) As Long
Declare Function GdipDeleteGraphics Lib "gdiplus.dll" Alias "GdipDeleteGraphics" (ByVal graphics As Dword) As Long
Declare Function GdipDrawImageRectI Lib "gdiplus.dll" Alias "GdipDrawImageRectI" (ByVal hGraphics???, ByVal nImage???, ByVal x&,ByVal y&, ByVal nWidth&, ByVal nHeight&) As Long

Declare Function Sub1( p1 As Any ) As Dword
Declare Function Sub2( p1 As Any, p2 As Any ) As Dword
Declare Function Sub3( p1 As Any, p2 As Any, p3 As Any ) As Dword
Declare Function Sub5( p1 As Any, p2 As Any, p3 As Any, p4 As Any, p5 As Any ) As Dword

%CWordLimit = 1000

%DefaultHiColor = %Black
%DefaultLoColor = %Red
%DefaultBGColor = %White

%PosHorRandom  = 1
%PosHorFreq    = 2
%PosHorLength  = 3
%PosHorAlpha   = 4
%PosRandom     = 5
%PosSymbols    = 6

%ThemeGradient = 0
%ThemeRandom   = 1
%ThemeSpectrum = 2
%ThemeList     = 3

%ListColor00 = 204      'Val("&H0000CC")
%ListColor01 = 759035   'Val("&HOB94FB")
%ListColor02 = 65535    'Val("&H00FFFF")
%ListColor03 = 52224    'Val("&H00CC00")
%ListColor04 = 12976131 'Val("&HC60003")
%ListColor05 = 16711680 'Val("&HFF0000")
%ListColor06 = 10955894 'Val("&HA72C76")
%ListColor07 = 12556543 'Val("&HBF98FF")
%ListColor08 = 10066329 'Val("&H999999")
%ListColor09 = 0        'Val("&H000000")

$ver = "1.01"

%IDT_Create       = 400
%IDT_Font         = 401
%IDT_Colors       = 402
%IDT_Settings     = 403
%IDT_Help         = 404
%IDT_Save         = 405
%IDT_Open         = 406
%IDT_New          = 407
%IDT_Words        = 408
%IDT_Image        = 409
%IDT_Patterns     = 410
%IDT_Lock         = 411

%IDC_TextIn       = 501
%IDC_Graphic      = 502
%IDC_Statusbar    = 503
%IDC_Toolbar      = 504
%IDC_LabelLo      = 505
%IDC_LabelHi      = 506
%IDC_ListBox      = 507
%IDC_GraphicL     = 508
%IDC_Default      = 509

%IDM_Sep          = 600
%IDM_ShowList     = 601
%IDM_Sample       = 602
%IDM_ColorBG      = 603
%IDM_ColorLo      = 604
%IDM_ColorHi      = 605
%IDM_MinWordWidth = 606
%IDM_MaxWordsToDisplay = 607
%IDM_ThemeList    = 608
%IDM_CharList     = 609
%IDM_HideText     = 610
%IDM_FontSizeMax  = 611
%IDM_FontSizeMin  = 612
%IDM_CopyImage    = 613
%IDM_SaveImage    = 614
%IDM_UseImage     = 615
%IDM_SelectImage  = 616
%IDM_CopyHiddenImage = 617
%IDM_FontBold     = 618
%IDM_FontItalic   = 619
%IDM_BadWordList  = 620
%IDM_HideBadWords = 621
%IDM_LowestAllowedFrequency = 622
%IDM_ShowFreq     = 623
%IDM_Rotation     = 624
%IDM_SaveAs       = 625
%IDM_ShowName     = 626
%IDM_ShowCFN      = 627
%IDM_ShowListAlpha= 628
%IDM_Stuff        = 629
%IDM_GrayScale    = 630
%IDM_ReloadImage  = 631
%IDM_ThemeGradient = 632
%IDM_ThemeRandom   = 633
%IDM_ThemeSpectrum  = 634
%IDM_SelectFont   = 635
%IDM_WordMarginH  = 636
%IDM_Boundary     = 637
%IDM_Redraw       = 638
%IDM_EditColorList= 639
%IDM_Draw         = 640
%IDM_Baseline     = 641
%IDM_UseSymbolAsBG= 642
%IDM_MaskColor    = 643
%IDM_LimitTime    = 644
%IDM_OpenSymbolFolder = 645
%IDM_WordMarginV  = 646
%IDM_CopyMask     = 647
%IDM_SaveWords    = 648
%IDM_RestoreWords = 649
%IDM_FastRemoval  = 650
%IDM_ShowSkipList = 651
%IDM_ShowExcluded = 652
%IDM_ShowCListAlpha = 653
%IDM_ShowCList    = 654
%IDM_ShowInfrequent = 655
%IDM_ShowShort    = 656
%IDM_FixedFont    = 657
%IDM_FixedFontSize= 658
%IDM_Left         = 659
%IDM_Right        = 660
%IDM_Up           = 661
%IDM_Down         = 662
%IDM_LeftS        = 663
%IDM_RightS       = 664
%IDM_UpS          = 665
%IDM_DownS        = 666
%IDM_ChangeColor  = 667
%IDM_AddWord      = 668
%IDM_ChangeText   = 669
%IDM_ChangeFontSize = 670
%IDM_Debug        = 671
%IDM_ClearConsole = 672

%IDM_EditCut      = 700
%IDM_EditCopy     = 701
%IDM_EditPaste    = 702
%IDM_EditDelete   = 703
%IDM_EditReplace  = 704
%IDM_EditGetFile  = 705
%IDM_EditGetURL   = 706
%IDM_EditClear    = 707

%IDM_PatternHorRandom  = 750
%IDM_PatternHorFreq    = 751
%IDM_PatternHorLength  = 752
%IDM_PatternHorAlpha   = 753
%IDM_PatternRandom     = 754
%IDM_PatternSymbols    = 755

%IDM_WordInfo     = 800
%IDM_WordRemove   = 801
%IDM_SetTarget    = 802
%IDM_OpenTarget   = 803
%IDM_ClearTarget  = 804
%IDM_ClearAllTargets   = 805
%IDM_RemoveWord   = 806
%IDM_RotateRemove = 807
%IDM_RotateCCW    = 808
%IDM_RotateCW     = 809

%IDC_ColorLabel   = 900
'900-920 reserved for color dialog use

Global hDlg,hGraphic,hTBContext,hHook,hImageList,hTextIn,hSymbol,hCloud As Dword
Global hToolbar,hPopupColors,hPopupSettings,hPopupWord,hBMP,hCopy,hConsole,hPopupPatterns As Dword
Global hPopupFont,hPopupWords,hPopupImage,hPopupSave,hFontDialog,hColorDialog,hPopupSymbols,hPopupHelp As Dword
Global OldPos,OnWord,HideText,OldProc,imgW,imgH,symW,symH,BadWordListInvalid, TimeIsUp, Debug As Long
Global ShowName,CValue,ColorChange,MaxLoops, Iterations, MaxIterations, Continue, qStart, qEnd, MaxTime,LimitTime As Long
Global BadWordList, Words(), InverseCharList,CFNname,LastURL,SessionFile As String
Global SkipList,ExcludedWordList, SkipFreqList, SkipWidthList, NewContent As String
Global FontsA(), FontsB(), FontsRA(), FontsRB(), FontsRRA(), FontsRRB() As Dword
Global CustomColorList As CustomColors, CFN As CFNData, GColors(), MoveInWork As Long

Function PBMain() As Long
   Local style&
   style& = %WS_TabStop Or %WS_Border Or  %ES_Left Or %ES_AutoHScroll Or %ES_AutoVScroll _
         Or %ES_MultiLine Or %ES_NoHideSel Or %ES_WantReturn Or %WS_VScroll
   Dialog New Pixels, 0, "gbCloud",300,300,580,500, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "aaa"
   Control Add TextBox, hDlg, %IDC_TextIn,"", 10,50,500,100, Style&
   Control Handle hDlg, %IDC_TextIn To hTextIn
   Control Add Graphic, hDlg, %IDC_Graphic, "", 10,155,590,280, %WS_Child Or %WS_Visible ,%WS_Ex_ClientEdge
   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Color -1, -2
   Graphic Clear CFN.ColorBG, 0
   Control Add Label, hDlg, %IDC_LabelHi,"",1,160,7,7, %WS_Border Or %SS_Notify
   Control Add Graphic, hDlg, %IDC_GraphicL,"",3,176,4,101
   Control Add Label, hDlg, %IDC_LabelLo,"",1,275,7,7, %WS_Border Or %SS_Notify
   DragAcceptFiles hDlg, %True
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local i,x,y,iResult As Long, pt,ptg,ptd As Point, temp$
   Local nmtb As TBNOTIFY Ptr, rc As RECT
   Static ddx, ddy As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         BuildSymbolMenus
         CreateSubFolders
         CreateExcludeList
         GetBadWordList
         BuildAcceleratorTable
         OldProc& = SetWindowLong(GetDlgItem(hDlg, %IDC_TextIn), %GWL_WndProc, CodePtr(NewProc))  'subclass
         Settings_INI "get"
         RestoreSession
         CreateGColors CFN.ColorHi, CFN.ColorLo
         LoadSymbol
         LoadCFNImage
         SetCaption
         BuildInverseCharList
         SetLabelColors
         CreateImageList
         CreateToolbar
         Graphic Clear CFN.ColorBG, 0
         CreateTextBoxContextMenu
         CreateToolbarContextMenu
         CreateWordContextMenu
         SetPopupMenuStates
         CreateFonts
         SetMenuValues
         Randomize Timer
         oldPos = -1
         If CFNname = Exe.Path$ + "temp\default.gbc" Then DrawCloud
      Case %WM_Destroy
         Settings_INI "save"
         SaveSession
         SetWindowLong GetDlgItem(hDlg,%IDC_TextIn), %GWL_WNDPROC, OldProc&   'un-subclass

     Case %WM_MouseMove           'posted to window that has captured the mouse
         If (Cb.WParam And %MK_LBUTTON) Then
            MoveInWork = 1
            OffSetRect CFN.CWords(oldPos).rc, _
            Lo(Word,Cb.LParam) + ddx - CFN.CWords(oldPos).rc.nLeft, _
            Hi(Word,Cb.LParam) + ddy - CFN.CWords(oldPos).rc.nTop
            RedrawCloud
         End If
     Case %WM_LButtonDown         'posted to window that has captured the mouse
         pt.x = CFN.CWords(oldPos).rc.nLeft
         pt.y = CFN.CWords(oldPos).rc.nTop
         ddx = pt.x - Lo(Word,Cb.LParam)
         ddy = pt.y -  Hi(Word,Cb.LParam)
     Case %WM_LButtonUp
         MoveInWork = 0

     Case %WM_SetCursor  'MouseMove
         If MoveInWork Then Exit Function
         GetCursorPos pt               'pt has xy screen coordinates
         ptd = pt : ptg = pt
         ScreenToClient hDlg, ptd       'pt now has dialog client coordinates
         ScreenToClient hGraphic, ptg       'pt now has dialog client coordinates
         If ChildWindowFromPoint(hDlg,ptd)=hGraphic Then
            For i = 1 To CFN.MaxCWords
               If CFN.CWords(i).vis Then
                   OnWord = 0
                   If PtInRect(CFN.CWords(i).rc,ptg) Then
                        OnWord = 1
                        Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Word: " + Trim$(CFN.CWords(i).Text) + "      Frequency: " + Str$(CFN.CWords(i).freq) + _
                        "      Color (RGB):  " + Str$(GetRValue(CFN.CWords(i).RGB))+ Str$(GetBValue(CFN.CWords(i).RGB))+ Str$(GetBValue(CFN.CWords(i).RGB)) + _
                        "      Target:  " + IIf$(Len(Trim$(CFN.CWords(i).target)),CFN.CWords(i).target,"<no target>")
                        If oldPos <> -1 Then
                            Graphic Copy hCopy, 0 To (CFN.CWords(oldPos).rc.nLeft,CFN.CWords(oldPos).rc.nTop)
                        End If
'                        CValue = i
                        DrawNew(i)
                        oldPos = i
                        Exit For
                   End If
               End If
            Next i
         Else
            OnWord = 0
         End If
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel
                Continue = 0

            Case %IDC_TextIn
                If Cb.CtlMsg = %EN_SetFocus Then Control Send hDlg, %IDC_TextIn, %EM_SetSel, 0, 0
            Case %IDT_New
                If MsgBoxX( "Are you sure?", %MB_OkCancel + %MB_IconQuestion, "New Cloud") = %IdOk Then
                    Control Set Text hDlg, %IDC_TextIn, "gbCloud"
                    SetCFNToDefaultValues
                    LoadSymbol
                    SetPopUpMenuStates
                    SetMenuValues
                    DrawCloud
                End If
            Case %IDT_Lock
                CFN.Lock = CFN.Lock Xor 1
            Case %IDT_Open
                SelectCFN
                LoadSymbol
                SetPopUpMenuStates
                RedrawCloud
            Case %IDT_Save
                SaveCFN
            Case %IDM_SaveAs
                SaveAs
            Case %IDT_Create
                DrawCloud
            Case %IDT_Font, %IDM_SelectFont
                temp$ = CFN.FontName
                SelectMainFont
                If temp$ <> CFN.FontName Then
                    RemoveFonts
                    CreateFonts
                    DrawCloud
                End If

            Case %IDM_MaxWordsToDisplay
               CenterOverDialog(300,225,x,y)
               iResult = CFN.MaxWordsToDisplay
               temp$ = InputBox$("Enter maximum words to display.","Max Words to Display",Str$(CFN.MaxWordsToDisplay),x,y)  'zero not allowed
               If (Val(temp$)>0) And (Val(temp$)<=%CWordLimit) And (Val(temp$)<> iResult) Then  'zero not allowed
                   CFN.MaxWordsToDisplay = Val(temp$) : DrawCloud : SetMenuValues
               Else
                   Beep
               End If

            Case %IDM_LowestAllowedFrequency
               CenterOverDialog(300,225,x,y)
               iResult = CFN.LowestAllowedFrequency
               temp$ = InputBox$("Enter minimum frequency to display in cloud.","Minimum Frequency",Str$(CFN.LowestAllowedFrequency),x,y)
               If (Val(temp$) > 0) And (Val(temp$)<>iResult) Then   'zero not allowed
                   CFN.LowestAllowedFrequency = Val(temp$)
                   SetMenuValues
                   If CFN.FastRemoval And (CFN.Patterns = %PosRandom Or CFN.Patterns = %PosSymbols) Then
                       RedrawCLoud
                   Else
                       DrawCloud
                   End If
               Else
                   Beep
               End If

            Case %IDM_MinWordWidth
               CenterOverDialog(300,225,x,y)
               iResult = CFN.MinWordWidth
               temp$ = InputBox$("Enter minimum word size to display.","Min Word Size",Str$(CFN.MinWordWidth),x,y)
               If (Val(temp$) > 0) And (Val(temp$)<> iResult) Then  'zero not allowed
                   CFN.MinWordWidth = Val(temp$)
                   SetMenuValues
                   If CFN.FastRemoval And (CFN.Patterns = %PosRandom Or CFN.Patterns = %PosSymbols) Then
                       RedrawCLoud
                   Else
                       DrawCloud
                   End If
               Else
                   Beep
               End If

            Case %IDM_WordMarginH
               CenterOverDialog(300,225,x,y)
               iResult = CFN.WordMarginH
               temp$ = InputBox$("Enter desired horizontal space between words (pixels).","Word Margin",Str$(CFN.WordMarginH),x,y)
               If Len(temp$) And (Val(temp$)>=0) And (Val(temp$) <> iResult) Then   'zero allowed
                   CFN.WordMarginH = Val(temp$)
                   DrawCloud : SetMenuValues
               Else
                   Beep
               End If
            Case %IDM_WordMarginV
               CenterOverDialog(300,225,x,y)
               iResult = CFN.WordMarginV
               temp$ = InputBox$("Enter desired space above/below words (pixels).","Word Margin",Str$(CFN.WordMarginV),x,y)
               If Len(temp$) And (Val(temp$)>=0) And (Val(temp$) <> iResult) Then  'zero allowed
                   CFN.WordMarginV = Val(temp$)
                   DrawCloud : SetMenuValues
               Else
                   Beep
               End If

            Case %IDM_FontSizeMin
               CenterOverDialog(300,225,x,y)
               iResult = CFN.FontSizeMin
               temp$ = InputBox$("Enter minimum cloud font size.","Min Font Size",Str$(CFN.FontSizeMin),x,y)
               If Len(temp$) And (Val(temp$) > 0) And (Val(temp$)<> iResult) Then   'zero not allowed
                   CFN.FontSizeMin = Val(temp$) : CreateFonts : DrawCloud : SetMenuValues
               End If

            Case %IDM_FontSizeMax
               CenterOverDialog(300,225,x,y)
               iResult = CFN.FontSizeMax
               temp$ = InputBox$("Enter maximum cloud font size.","Max Font Size",Str$(CFN.FontSizeMax),x,y)
               If Len(temp$) And (Val(temp$) > 0) And (Val(temp$)<> iResult) Then   'zero not allowed
                   CFN.FontSizeMax = Val(temp$) : CreateFonts : DrawCloud : SetMenuValues
               End If

            Case %IDM_CharList
               CenterOverDialog(300,225,x,y)
               temp$ = InputBox$("Enter allowed characters.","Character List",Trim$(CFN.CharList),x,y)
               If Len(temp$) And (Trim$(CFN.CharList) <> Trim$(temp$)) Then
                   CFN.CharList = temp$
                   BuildInverseCharList
                   DrawCloud
               End If

            Case %IDM_RestoreWords
               If IsFile(Exe.Path$ + "temp\words.txt") Then
                   Open Exe.Path$ + "temp\words.txt" For Binary As #1
                   Get$ #1, Lof(1), temp$
                   Close #1
                   Control Set Text hDlg, %IDC_TextIn, temp$
               Else
                   Beep
               End If
            Case %IDM_SaveWords
               Control Get Text hDlg, %IDC_TextIn To temp$
               CreateSubFolders
               Open Exe.Path$ + "temp\words.txt" For Output As #1
               Print #1, temp$
               Close #1
            Case %IDM_BadWordLIst
               iResult = Shell ("notepad.exe " + Exe.Path$ + "temp\exclude.txt", 1)  'does not wait for it to close
               BadWordListInvalid = 1
            Case %IDT_Colors
                Select Case CFN.ThemeColor
                    Case %ThemeGradient
                        If MsgBoxX("Set FG/BG colors to default values?", %MB_OkCancel + %MB_IconQuestion, "Reset FG/BG Colors") = %IdOk Then
                            CFN.ColorLo = %DefaultLoColor : CFN.ColorHi = %DefaultHiColor
                            CreateGColors CFN.ColorHi, CFN.ColorLo : ReDrawCloud
                            SetLabelColors : ReDrawCloud
                        End If
                    Case Else : RedrawCloud
                End Select
            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbcloud.htm"
               iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_ShowCFN        : DisplayCFN

            Case %IDM_ShowList       : DisplayResultFrequency(1)     '1-visible only 0-oomplete list
            Case %IDM_ShowCList      : DisplayResultFrequency(0)     '1-visible only 0-oomplete list

            Case %IDM_ShowListAlpha  : DisplayResultAlpha(1)  '1-visible only 0-complete list
            Case %IDM_ShowCListAlpha : DisplayResultAlpha(0)  '1-visible only 0-complete list

            Case %IDM_ShowSkipList   : DisplaySkipList
            Case %IDM_ShowExcluded   : DisplayExcluded

            Case %IDM_ShowInfrequent : DisplaySkipFreqList
            Case %IDM_ShowShort      : DisplaySkipWidthList

            Case %IDM_UseSymbolAsBG
                CFN.UseSymbolAsBG = CFN.UseSymbolAsBG Xor 1
                Menu Set State hPopupImage, ByCmd %IDM_UseSymbolAsBG, CFN.UseSymbolAsBG * 8
                RedrawCloud
'                If CFN.UseSymbolAsBG And (CFN.Patterns=%PosSymbols) Then LoadSymbol : SetSymbolScale : DrawCloud Else ReDrawCloud
            Case %IDM_SelectImage
                temp$ = CFN.CFNImage
                SelectImage
                If temp$ <> CFN.CFNImage Then
                   LoadCFNImage
                   RedrawCloud
                End If
            Case %IDM_EditGetFile
                OpenTextFile
            Case %IDM_EditGetURL
               CenterOverDialog(300,225,x,y)
               temp$ = InputBox$("Enter URL.","Get URL Text",LastURL,x,y)
               If Len(temp$) Then : LastURL = temp$ : GetURLText LastURL
            Case %IDM_CopyHiddenImage
                Clipboard Reset
                Clipboard Set Bitmap hBMP
            Case %IDM_CopyMask
                Clipboard Reset
                Clipboard Set Bitmap hSymbol
            Case %IDM_CopyImage
                Clipboard Reset
                Clipboard Set Bitmap hGraphic
            Case %IDM_SaveImage
                Graphic Save Exe.Path$ + "temp\gbcloud.bmp"
            Case %IDM_Sample     : Control Set Text hDlg, %IDC_TextIn, SampleContent
            Case %IDM_EditCut    : Control Send hDlg, %IDC_TextIn, %WM_CUT, 0, 0
            Case %IDM_EditCopy   : Control Send hDlg, %IDC_TextIn, %WM_COPY, 0, 0
            Case %IDM_EditPaste  : Control Send hDlg, %IDC_TextIn, %WM_PASTE, 0, 0
            Case %IDM_EditDelete : Control Send hDlg, %IDC_TextIn, %WM_CLEAR, 0, 0
            Case %IDM_EditClear  : Control Set Text hDlg, %IDC_TextIn, ""
            Case %IDM_EditReplace
                Clipboard Get Text temp$
                Control Set Text hDlg, %IDC_TextIn, temp$
            Case %IDM_MaskColor
                iResult = CFN.MaskColor
                CFN.MaskColor = SelectColor(CFN.MaskColor)
                If iResult <> CFN.MaskColor Then DrawCloud
            Case %IDM_ColorBG                 : CFN.ColorBG = SelectColor(CFN.ColorBG) : ReDrawCloud
            Case %IDM_ColorLo, %IDC_LabelLo
                CFN.ColorLo = SelectColor(CFN.ColorLo) : SetLabelColors
                If CFN.ThemeColor = %ThemeGradient Then CreateGColors CFN.ColorHi, CFN.ColorLo : ReDrawCloud
            Case %IDM_ColorHi, %IDC_LabelHi
                CFN.ColorHi = SelectColor(CFN.ColorHi) : SetLabelColors
                If CFN.ThemeColor = %ThemeGradient Then CreateGColors CFN.ColorHi, CFN.ColorLo : RedrawCloud

            Case %IDM_HideBadWords
                CFN.HideBadWords = CFN.HideBadWords Xor 1
                Menu Set State hPopupWords, ByCmd %IDM_HideBadWords, CFN.HideBadWords * 8
                DrawCloud
            Case %IDM_UseImage, %IDT_Image
                CFN.UseBGImage = CFN.UseBGImage Xor 1
                Menu Set State hPopupImage, ByCmd %IDM_UseImage, CFN.UseBGImage * 8
                Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Image, %TBState_Checked * CFN.UseBGImage Or %TBState_Enabled
                LoadCFNImage : ReDrawCloud
            Case %IDM_FontBold
                CFN.FontBold = CFN.FontBold Xor 1
                Menu Set State hPopupFont, ByCmd %IDM_FontBold, CFN.FontBold * 8
                RemoveFonts
                CreateFonts
                RedrawCloud
            Case %IDM_FontItalic
                CFN.FontItalic = CFN.FontItalic Xor 1
                Menu Set State hPopupFont, ByCmd %IDM_FontItalic, CFN.FontItalic * 8
                RemoveFonts
                CreateFonts
                RedrawCloud
            Case %IDM_FixedFont
                CFN.FixedFont = CFN.FixedFont Xor 1
                Menu Set State hPopupFont, ByCmd %IDM_FixedFont, CFN.FixedFont * 8
                DrawCloud
            Case %IDM_FixedFontSize
               CenterOverDialog(300,225,x,y)
               iResult = CFN.FixedFontSize
               temp$ = InputBox$("Enter fixed font size.","Fixed Font Size",Str$(CFN.FixedFontSize),x,y)  'zero not allowed
               If (Val(temp$)>=CFN.FontSizeMin) And (Val(temp$)<=CFN.FontSizeMax) And (Val(temp$)<> iResult) Then  'zero not allowed
                   CFN.FixedFontSize = Val(temp$) : DrawCloud : SetMenuValues
               Else
                   Beep
               End If

            Case %IDM_FastRemoval
                CFN.FastRemoval = CFN.FastRemoval Xor 1
                Menu Set State hPopupWords, ByCmd %IDM_FastRemoval, CFN.FastRemoval * 8
            Case %IDM_Rotation
                CFN.Rotation = CFN.Rotation Xor 1
                Menu Set State hPopupWords, ByCmd %IDM_Rotation, CFN.Rotation * 8
                DrawCloud
            Case %IDM_ShowFreq, %IDT_Words
                CFN.ShowFrequency = CFN.ShowFrequency Xor 1
                Menu Set State hPopupWords, ByCmd %IDM_ShowFreq, CFN.ShowFrequency * 8
                Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Words, %TBState_Checked * CFN.ShowFrequency Or %TBState_Enabled
                RedrawCloud
            Case %IDM_LimitTime
                LimitTime = LimitTime Xor 1
                Menu Set State hPopupSettings, ByCmd %IDM_LimitTime, LimitTime * 8
            Case %IDM_ShowName
                ShowName = ShowName Xor 1
                Menu Set State hPopupSettings, ByCmd %IDM_ShowName, ShowName * 8
                SetCaption
            Case %IDM_HideText, %IDT_Settings
                HideText = HideText Xor 1
                Menu Set State hPopupSettings, ByCmd %IDM_HideText, HideText * 8
                ResizeWindow(1)
            Case %IDM_GrayScale
                CFN.GrayScale = CFN.GrayScale Xor 1
                Menu Set State hPopupImage, ByCmd %IDM_GrayScale, CFN.GrayScale * 8
                RedrawCloud
            Case %IDM_Baseline
                CFN.Baseline = CFN.Baseline Xor 1
                Menu Set State hPopupWords, ByCmd %IDM_Baseline, CFN.Baseline * 8
                Select Case CFN.Patterns
                    Case %PosHorRandom, %PosHorFreq, %PosHorLength, %PosHorAlpha : DrawCloud
                End Select
            Case %IDM_WordInfo : ShowWordInfo   'show info about most recently mouse-overed (underlined) word
            Case %IDM_SetTarget
               CenterOverDialog(300,225,x,y)
               temp$ = InputBox$("Enter word target.","Set Word Target",Trim$(CFN.CWords(CValue).target),x,y)
               If Len(Trim$(temp$)) Then CFN.CWords(CValue).target = temp$
            Case %IDM_OpenTarget  : OpenTarget
            Case %IDM_ClearTarget : CFN.CWords(CValue).target = ""
            Case %IDM_ClearAllTargets : ClearAllTargets
            Case %IDM_RemoveWord
                CFN.CWords(CValue).vis = 0
                RedrawCloud
            Case %IDM_RotateRemove
                AdjustRotation(CValue,0)
                RedrawCloud
            Case %IDM_RotateCCW
                AdjustRotation(CValue,5)
                RedrawCloud
            Case %IDM_RotateCW
                AdjustRotation(CValue,6)
                RedrawCloud
            Case %IDM_ThemeGradient
                CreateGColors  CFN.ColorHi, CFN.ColorLo   'use CFN.ColorHi and CFN.ColorLo
                CFN.ThemeColor = %ThemeGradient : SetPopupMenuStates : RedrawCloud
            Case %IDM_ThemeRandom
                'use randome colors
                CFN.ThemeColor = %ThemeRandom   : SetPopupMenuStates : RedrawCloud
            Case %IDM_ThemeSpectrum
                'use preset colors %rgb_Violet and %Red
                CreateGColors %Red, %rgb_Violet
                CFN.ThemeColor = %ThemeSpectrum  : SetPopupMenuStates : RedrawCloud
            Case %IDM_ThemeList
                'use colors from list
                CFN.ThemeColor = %ThemeList      : SetPopupMenuStates : RedrawCloud


            Case %IDM_Boundary
                CFN.DrawBoundary = CFN.DrawBoundary Xor 1
                RedrawCloud
            Case %IDM_Redraw
                RedrawCloud
            Case %IDM_Draw
                DrawCloud
            Case %IDM_EditColorList  : EditColorList

            Case %IDM_PatternHorFreq                : CFN.Patterns = %PosHorFreq    : SetPopupMenuStates : DrawCloud
            Case %IDM_PatternHorRandom              : CFN.Patterns = %PosHorRandom  : SetPopupMenuStates : DrawCloud
            Case %IDM_PatternHorLength              : CFN.Patterns = %PosHorLength  : SetPopupMenuStates : DrawCloud
            Case %IDM_PatternHorAlpha               : CFN.Patterns = %PosHorAlpha   : SetPopupMenuStates : DrawCloud
            Case %IDM_PatternSymbols                : CFN.Patterns = %PosSymbols    : SetPopupMenuStates : LoadSymbol : SetSymbolScale : DrawCloud
            Case %IDM_PatternRandom                 : CFN.Patterns = %PosRandom     : SetPopupMenuStates : DrawCloud
            Case %IDT_Patterns                      : ReDrawCloud

            Case 1001 To 1100      'up to 100 symbols
                Menu Get Text hPopupSymbols, ByCmd Cb.Ctl To temp$
                CFN.SymbolName = Exe.Path$ + "masks\" + temp$
                SetMenuValues
                LoadSymbol
                SetSymbolScale
                If CFN.UseSymbolAsBG Then ReDrawCloud
'                If CFN.Patterns=%PosSymbols Then DrawCloud
            Case %IDM_OpenSymbolFolder
                ShellExecute(hDlg, "Open", (PathName$(Path,CFN.SymbolName)), $Nul, $Nul, %SW_Restore)
            Case %IDM_Left   : MoveWord("left",100)
            Case %IDM_Right  : MoveWord("right",100)
            Case %IDM_Up     : MoveWord("up",100)
            Case %IDM_Down   : MoveWord("down",100)
            Case %IDM_LeftS  : MoveWord("left",1)
            Case %IDM_RightS : MoveWord("right",1)
            Case %IDM_UpS    : MoveWord("up",1)
            Case %IDM_DownS  : MoveWord("down",1)
            Case %IDM_ChangeColor
                iResult = CFN.CWords(CValue).manualRGB
                CFN.CWords(CValue).manualRGB = SelectColor(CFN.CWords(CValue).manualRGB)
                If iResult <> CFN.CWords(CValue).manualRGB Then ReDrawCloud
            Case %IDM_ChangeText
               CenterOverDialog(300,225,x,y)
               temp$ = CFN.CWords(CValue).Text
               temp$ = InputBox$("Enter new text.","Change Text",Trim$(CFN.CWords(CValue).Text),x,y)
               If Len(Trim$(temp$)) And (Trim$(temp$) <> Trim$(CFN.CWords(CValue).Text)) Then  'zero not allowed
                   CFN.CWords(CValue).Text = temp$
                   ResizeWordBoundary (CValue)
                   RedrawCloud
               Else
                   Beep
               End If
            Case %IDM_ChangeFontSize
               CenterOverDialog(300,225,x,y)
               temp$ = CFN.CWords(CValue).Text
               temp$ = InputBox$("Enter new font size.","Change Font Size",Str$(CFN.CWords(CValue).fontsize),x,y)
               If Len(Trim$(temp$)) And (Val(temp$) <> CFN.CWords(CValue).fontsize) Then  'zero not allowed
                   CFN.CWords(CValue).fontsize = Val(temp$)
                   ResizeWordBoundary (CValue)
                   RedrawCloud
               Else
                   Beep
               End If
            Case %IDM_AddWord : AddWord
            Case %IDM_Debug
                Debug = Debug Xor 1
                If Debug Then
                   cPrint "Console Display Enabled" + $CrLf + String$(30,"=")
                   Control Set Focus hDlg, %IDC_Graphic
                Else
                   FreeConsole
                   hConsole = 0
                End If

            Case %IDM_ClearConsole : ClearConsole
         End Select

      Case %WM_Notify
          nmtb = Cb.LParam
          Select Case @nmtb.hdr.Code
             Case %TBN_DROPDOWN
                Select Case @nmtb.iItem
                   Case %IDT_Help
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Colors
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpColors, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Settings
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Font
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpFont, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Image
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpImage, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Save
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpSave, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Words
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpWords, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                   Case %IDT_Patterns
                      BuildSymbolMenus
                      Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                      Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                      Call TrackPopupMenu (hPopUpPatterns, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
               End Select
          End Select

      Case %WM_Size
          ReSizeWindow(0)
      Case %WM_ContextMenu
         GetCursorPos pt               'pt has xy screen coordinates
         ptd = pt : ptg = pt
         ScreenToClient hDlg, ptd       'pt now has dialog client coordinates
         ScreenToClient hGraphic, ptg       'pt now has dialog client coordinates
         If ChildWindowFromPoint(hDlg,ptd)=hGraphic Then
            For i = 1 To CFN.MaxCWords
               If CFN.CWords(i).vis Then
                   If PtInRect(CFN.CWords(i).rc,ptg) Then
                        CValue = i
                        TrackPopupMenu hPopupWord, %TPM_LeftAlign, pt.x, pt.y, 0, Cb.Hndl, ByVal 0
                        Exit For
                   End If
               End If
            Next i
           Function = 1 : Exit Function
         End If
      Case %WM_LButtonDblClk
         GetCursorPos pt               'pt has xy screen coordinates
         ptd = pt : ptg = pt
         ScreenToClient hDlg, ptd       'pt now has dialog client coordinates
         ScreenToClient hGraphic, ptg       'pt now has dialog client coordinates
         If ChildWindowFromPoint(hDlg,ptd)=hGraphic Then
            For i = 1 To CFN.MaxCWords
               If CFN.CWords(i).vis Then
                   If PtInRect(CFN.CWords(i).rc,ptg) Then
                        CValue = i     'global variable so that ShowWordInfo knows which .CWords(i) to use
                        OpenTarget 'ShowWordInfo
                        Exit For
                   End If
               End If
            Next i
         End If
      Case %WM_DropFiles
           temp$ = GetDroppedFileName(Cb.WParam)
           If Right$(temp$,4) = ".lnk" Then temp$ = LCase$(GetLinkInfo(temp$))
           Open temp$ For Binary As #1
           Get$ #1, Lof(1), temp$
           Close #1
           Control Set Text hDlg, %IDC_TextIn, temp$
   End Select
End Function

Sub DisplayResultAlpha(Flag As Long)  '1=visible only 0=complete
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long,result$
    If CFN.MaxCWords = 0 Then Beep : Exit Sub
    Dim tempArray(CFN.MaxCWords) As String
    CreateSubFolders
    For i = 1 To CFN.MaxCWords
        If Flag Then
           If CFN.CWords(i).vis Then result$ = result$ + Trim$(CFN.CWords(i).Text) + $CrLf
        Else
           result$ = result$ + Trim$(CFN.CWords(i).Text) + $CrLf
        End If
    Next i
    result$ = Trim$(result$,$CrLf)
    ReDim tempArray(ParseCount(result$, $CrLf)-1)
    Parse result$, tempArray(), $CrLf
    Array Sort tempArray(), Ascend
    Open Exe.Path$ + "temp\results.txt" For Output As #1
    If Flag Then
        Print #1, "Visible words (alpha sort)"
    Else
        Print #1, "All words (alpha sort)"
    End If
    For i = 0 To UBound(tempArray)
        Print #1, Format$(i+1,"0000") + "  " + tempArray(i)
    Next i
    Close #1
    i = Shell ("notepad.exe " + Exe.Path$ + "temp\results.txt", 1)  'does not wait for it to close
End Sub

Sub DisplaySkipFreqList
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long,result$
    If Len(SkipFreqList) = 0 Then
        MsgBoxX "No words were rejected for low frequency.", %MB_Ok = %MB_IconInformation, "Infrequent WordList"
        Exit Sub
    End If
    CreateSubFolders
    result$ = Trim$(SkipFreqList,$CrLf)
    ReDim tempArray(ParseCount(result$, $CrLf)-1) As String
    Parse result$, tempArray(), $CrLf
    Array Sort tempArray(), Ascend
    Open Exe.Path$ + "temp\results.txt" For Output As #1
    Print #1, "Words skipped (frequency less than " + Str$(CFN.LowestAllowedFrequency) + ")"
    For i = 0 To UBound(tempArray)
        Print #1, Format$(i+1,"0000") + "  " + tempArray(i)
    Next i
    Close #1
    i = Shell ("notepad.exe " + Exe.Path$ + "temp\results.txt", 1)  'does not wait for it to close
End Sub

Sub DisplaySkipWidthList
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long,result$
    If Len(SkipWidthList) = 0 Then
        MsgBoxX "No words were rejected for low width.", %MB_Ok = %MB_IconInformation, "Short Word List"
        Exit Sub
    End If
    CreateSubFolders
    result$ = Trim$(SkipWidthList,$CrLf)
    ReDim tempArray(ParseCount(result$, $CrLf)-1) As String
    Parse result$, tempArray(), $CrLf
    Array Sort tempArray(), Ascend
    Open Exe.Path$ + "temp\results.txt" For Output As #1
    Print #1, "Words skipped (width less than " + Str$(CFN.MinWordWidth) + ")"
    For i = 0 To UBound(tempArray)
        Print #1, Format$(i+1,"0000") + "  " + tempArray(i)
    Next i
    Close #1
    i = Shell ("notepad.exe " + Exe.Path$ + "temp\results.txt", 1)  'does not wait for it to close
End Sub

Sub DisplaySkipList
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long,result$
    If Len(SkipList) = 0 Then
        MsgBoxX "No words were unplaced for fit or time.", %MB_Ok = %MB_IconInformation, "Skip List"
        Exit Sub
    End If
    CreateSubFolders
    result$ = Trim$(SkipList,$CrLf)
    ReDim tempArray(ParseCount(result$, $CrLf)-1) As String
    Parse result$, tempArray(), $CrLf
    Array Sort tempArray(), Ascend
    Open Exe.Path$ + "temp\results.txt" For Output As #1
    Print #1, "Words skipped (could not place or out of time)"
    For i = 0 To UBound(tempArray)
        Print #1, Format$(i+1,"0000") + "  " + tempArray(i)
    Next i
    Close #1
    i = Shell ("notepad.exe " + Exe.Path$ + "temp\results.txt", 1)  'does not wait for it to close
End Sub

Sub DisplayExcluded
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long,result$
    If Len(ExcludedWordList) = 0 Then
        MsgBoxX "No words were excluded.", %MB_Ok = %MB_IconInformation, "Excluded WordList"
        Exit Sub
    End If
    CreateSubFolders
    result$ = Trim$(ExcludedWordList,$CrLf)
    ReDim tempArray(ParseCount(result$, $CrLf)-1) As String
    Parse result$, tempArray(), $CrLf
    Array Sort tempArray(), Ascend
    Open Exe.Path$ + "temp\results.txt" For Output As #1
    Print #1, "Words skipped (on exclusion list)"
    For i = 0 To UBound(tempArray)
        Print #1, Format$(i+1,"0000") + "  " + tempArray(i)
    Next i
    Close #1
    i = Shell ("notepad.exe " + Exe.Path$ + "temp\results.txt", 1)  'does not wait for it to close
End Sub

Sub DisplayResultFrequency(Flag As Long)
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long,result$
    If CFN.MaxCWords = 0 Then Beep : Exit Sub
    Dim tempArray(CFN.MaxCWords) As String
    CreateSubFolders
    For i = 1 To CFN.MaxCWords
        If Flag Then
           If CFN.CWords(i).vis Then result$ = result$ + Format$(CFN.CWords(i).freq,"0000") + "   " + Trim$(CFN.CWords(i).Text) + $CrLf
        Else
           result$ = result$ + Format$(CFN.CWords(i).freq,"0000") + "   " + Trim$(CFN.CWords(i).Text) + $CrLf
        End If
    Next i
    result$ = Trim$(result$,$CrLf)
    ReDim tempArray(ParseCount(result$, $CrLf)-1)
    Parse result$, tempArray(), $CrLf
    Array Sort tempArray(), Descend
    Open Exe.Path$ + "temp\results.txt" For Output As #1
    If Flag Then
        Print #1, "Visible words (frequency sort)"
    Else
        Print #1, "All words (frequency sort)"
    End If
    Print #1, Join$(tempArray(),$CrLf)
    Close #1
    i = Shell ("notepad.exe " + Exe.Path$ + "temp\results.txt", 1)  'does not wait for it to close
End Sub

Sub BuildAcceleratorTable
   If Debug Then cPrint LCase$(FuncName$)
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(11)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDT_Help             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H      : ac(c).cmd   = %IDM_CopyHiddenImage  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_I      : ac(c).cmd   = %IDM_CopyImage        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S      : ac(c).cmd   = %IDM_ShowCFN          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T      : ac(c).cmd   = %IDM_Boundary         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M      : ac(c).cmd   = %IDM_CopyMask         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D      : ac(c).cmd   = %IDM_Debug            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E      : ac(c).cmd   = %IDM_ClearConsole     : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Left  : ac(c).cmd   = %IDM_LeftS       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Right : ac(c).cmd   = %IDM_RightS      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Up    : ac(c).cmd   = %IDM_UpS         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Down  : ac(c).cmd   = %IDM_DownS       : Incr c

   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function SampleContent() As String
    If Debug Then cPrint LCase$(FuncName$)
    Function = "Paste the words." + $CrLf + "Press the create button." + $CrLf + "See the word cloud." + $CrLf + "Nice word cloud!"
End Function

Sub ReDrawCloud
    If Debug Then cPrint LCase$(FuncName$)
    Local i,w,h As Long
'    MousePtr 11  - took out because it caused flickering when moving a word with the mouse
    If hCopy Then Graphic Attach hCopy,0 : Graphic Bitmap End : hCopy = 0

    'cloud will be drawn in memory first to hCloud, then copied over to the main app Graphic control
    Control Get Client hDlg, %IDC_Graphic To w,h
    Graphic Attach hCloud, 0

    'display background image (grayscale is required)
    Graphic Color -1, -2
    Graphic Set StretchMode %HalfTone
    If CFN.UseBGImage Then
        If CFN.UseSymbolAsBG Then
            Graphic Stretch Page hSymbol, 0  'use CFN.SymboName
        Else
            Graphic Stretch hBMP, 0, (0,0)-(imgW-1,imgH-1) To (0,0)-(w-1,h-1)      'use CFN.CFNImage
        End If
        If CFN.GrayScale Then CreateGrayImage
    Else
        Graphic Clear CFN.ColorBG, 0
    End If

    'set color, vis (random/symbol only) then print words
    CFN.VisibleWords = 0
    For i = 1 To CFN.MaxCWords

        If CFN.FastRemoval And (CFN.Patterns = %PosRandom Or CFN.Patterns = %PosSymbols) Then
            If CFN.CWords(i).freq < CFN.LowestAllowedFrequency Then CFN.CWords(i).vis = 0
            If Len(Trim$(CFN.CWords(i).Text)) < CFN.MinWordWidth Then CFN.CWords(i).vis = 0
        End If

        If CFN.CWords(i).vis Then
            Incr CFN.VisibleWords
            If CFN.CWords(i).manualRGB = -1 Then
                Select Case CFN.ThemeColor
                    Case %ThemeGradient
    '                    CFN.CWords(i).RGB = GColors(100*CFN.CWords(i).freq/CFN.MaxCWords)         'gradient
                        CFN.CWords(i).RGB = GColors(100*(CFN.CWords(i).freq-CFN.MinFreq+1)/CFN.FreqRange)   'gradient
                    Case %ThemeRandom
                        CFN.CWords(i).RGB = RGB(Rnd(0,255),Rnd(0,255),Rnd(0,255))                 'random
                    Case %ThemeSpectrum
                        CFN.CWords(i).RGB = GColors(100*CFN.CWords(i).freq/CFN.MaxFreq)           'full spectrum
                    Case %ThemeList
                        CFN.CWords(i).RGB = CFN.Colors(Min(10*CFN.CWords(i).freq/CFN.MaxFreq, 9)) 'from list
                End Select
            Else
                CFN.CWords(i).RGB = CFN.CWords(i).manualRGB
            End If
            Graphic Color CFN.CWords(i).RGB
            'box
            If CFN.DrawBoundary Then Graphic Box (CFN.CWords(i).rc.nLeft,CFN.CWords(i).rc.nTop) - (CFN.CWords(i).rc.nRight,CFN.CWords(i).rc.nBottom)
            'text
            If CFN.Rotation And (CFN.CWords(i).rot=6) Then
                Graphic Set Font FontsRRA(CFN.CWords(i).FontSize)
                Graphic Set Pos (CFN.CWords(i).rc.nRight-CFN.WordMarginH,CFN.CWords(i).rc.nTop+CFN.WordMarginV)
            ElseIf CFN.Rotation And (CFN.CWords(i).rot=5) Then
                Graphic Set Font FontsRA(CFN.CWords(i).FontSize)
                Graphic Set Pos (CFN.CWords(i).rc.nLeft+CFN.WordMarginH,CFN.CWords(i).rc.nBottom-CFN.WordMarginV)
            Else
                Graphic Set Font FontsA(CFN.CWords(i).FontSize)
                Graphic Set Pos (CFN.CWords(i).rc.nLeft+CFN.WordMarginH,CFN.CWords(i).rc.nTop+CFN.WordMarginV)
            End If
            If CFN.ShowFrequency Then
                Graphic Print Trim$(CFN.CWords(i).Text);
            Else
                Graphic Print Trim$(CFN.CWords(i).Text)
            End If
            'print subscript (frequency)
            If CFN.ShowFrequency Then
                Graphic Text Size Trim$(CFN.CWords(i).Text) To w,h
                If CFN.Rotation And (CFN.CWords(i).rot=6) Then
                    Graphic Set Pos Step (-0.7*h,0)
                    Graphic Set Font FontsRRA(8)
                    Graphic Print Str$(CFN.CWords(i).freq)
                ElseIf CFN.Rotation And (CFN.CWords(i).rot=5) Then
                    Graphic Set Pos Step (0.7*h,0)
                    Graphic Set Font FontsRA(8)
                    Graphic Print Str$(CFN.CWords(i).freq)
                Else
                    Graphic Set Pos Step (0,0.7*h)
                    Graphic Set Font FontsA(8)
                    Graphic Print Str$(CFN.CWords(i).freq)
                End If
            End If
         End If
    Next i

'    Graphic Set Font 0
    Graphic Attach hDlg, %IDC_Graphic, ReDraw
    Graphic Copy hCloud,0
    Graphic ReDraw

'    MousePtr 0
End Sub

Sub DrawCloud
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$,i,iPos As Long, r As Single

    If CFN.Lock Then
        Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Design change attempted - blocked!
        Beep
        Sleep 500
        Beep
        Exit Sub
    End If

    MousePtr 11

    'remove invalid characters
    Control Get Text hDlg, %IDC_TextIn To temp$
'    Replace Any InverseCharList With Space$(Len(InverseCharList)) In temp$
'    temp$ = Shrink$(LCase$(temp$)," ")          ' + InverseCharList)
    temp$ = Shrink$(LCase$(temp$)," "+InverseCharList)          ' + InverseCharList)

    'if no content, no action required
    If Len(Trim$(temp$)) = 0 Then
        CFN.MaxCWords = 0
        RedrawCloud
        Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, ""
        MousePtr 0
        Exit Sub
    End If

    'get sorted list of all words
    ReDim Words(ParseCount(temp$, " ")-1)
    Parse temp$, Words(), " "
    Array Sort Words(), Descend   'alpha sort so can get frequency
    CFN.WordsInSource = UBound(Words)+1

    'create CFN.CWords() - CWord list and frequency
    iPos = 1 : CFN.CWords(iPos).Text = Words(0) : CFN.CWords(iPos).freq = 1 : CFN.MaxFreq = 1 : CFN.MinFreq = 1
    For i = 1 To UBound(Words)
        If Words(i) = Words(i-1) Then
            'same word
            Incr CFN.CWords(iPos).freq
        Else
            'new word
            Incr iPos
            CFN.CWords(iPos).Text = Words(i)
            CFN.CWords(iPos).freq = 1
        End If
    Next i

    'sort CFN.CWords by frequency
    CFN.UniqueWordsInSource = iPos
    ReDim XWord(1 To iPos) As CWord At VarPtr(CFN.CWords(1))
    Array Sort XWord(), Call CustomFrequencySort()

    'remove too low freq, too low width, bad words
    ExcludedWordList = "" : SkipFreqList = "" : SkipWidthList = ""
    If BadWordListInvalid Then GetBadWordList : BadWordListInvalid = 0  'in case user edits during session
    iPos = 0
    For i = 1 To UBound(XWord)
        'remove bad words, too low freq, to short word
        If CFN.HideBadWords And InStr(BadWordList, " " + Words(i) + " ") Then
             ExcludedWordList = ExcludedWordList + $CrLf + Words(i)
             Iterate For
        End If
        If CFN.CWords(i).freq < CFN.LowestAllowedFrequency   Then
            SkipFreqList = SkipFreqList + $CrLf + Words(i)
            Iterate For
        End If
        If Len(Trim$(CFN.CWords(i).Text)) < CFN.MinWordWidth Then
            SkipWidthList = SkipWidthList + $CrLf + Words(i)
            Iterate For
        End If
        'accept the word
        Incr iPos
        CFN.CWords(iPos) = CFN.CWords(i)
        'determine minfreq and max freq
        CFN.MinFreq = Min(CFN.MinFreq,CFN.CWords(iPos).freq)
        CFN.MaxFreq = Max(CFN.MaxFreq,CFN.CWords(iPos).freq)
        If iPos = CFN.MaxWordsToDisplay Then Exit For
    Next i
    CFN.FreqRange = CFN.MaxFreq - CFN.MinFreq + 1
    CFN.MaxCWords = iPos

    'set manual color, visible, font sizes, rotation
    For i = 1 To CFN.MaxCWords
        'manual color
        CFN.CWords(i).manualRGB = -1
        'visible
        CFN.CWords(i).vis = 1        'all words left are to be displayed (unless can't fit - see SetPosX functions)
        'font size
        If CFN.FixedFont Then
            CFN.CWords(i).fontsize = CFN.FixedFontSize
        Else
            r = CFN.CWords(i).Freq / CFN.MaxFreq
            CFN.CWords(i).fontSize = (CFN.FontSizeMax-CFN.FontSizeMin)*(CFN.CWords(i).freq-CFN.MinFreq+1)/CFN.FreqRange + CFN.FontSizeMin
        End If
        'rotation
        Select Case CFN.Patterns
            Case %PosRandom, %PosSymbols
                CFN.CWords(i).rot = Rnd(0,6)  '0-4 % will be non-rotated  5=rotate up  6= rotate down
            Case %PosHorRandom, %PosHorFreq, %PosHorLength, %PosHorAlpha
                CFN.CWords(i).rot = 0   'no rotation for these themes
        End Select
    Next i

    'set position
    Select Case CFN.Patterns
        Case %PosHorFreq   : SetHorizontalPositions
        Case %PosHorRandom : SetHorizontalPositions
        Case %PosHorLength : SetHorizontalPositions
        Case %PosHorAlpha  : SetHorizontalPositions
        Case %PosRandom    : SetRandomPositions
        Case %PosSymbols   : SetSymbolPositions
    End Select

    ReDrawCloud

    If CFN.MaxCWords Then
        Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, _
             "Source Words: " + Str$(CFN.WordsInSource) + _
             "    Unique Source Words: " + Str$(CFN.UniqueWordsInSource) + _
             "    Words in Cloud: " + Str$(CFN.VisibleWords) + _
             "    Iterations: " + Format$(Iterations,"#,###,###,##0")
    End If
    SkipList = Trim$(SkipList,$CrLf)
    If Len(SkipList) Then
        i = ParseCount(SkipList,$CrLf)
        If TimeIsUp Then
            If i < 26 Then  '26 should fit on the screen easily
                MsgBox "Ran out of time. Unable to place these words in the cloud space:" + $CrLf + $CrLf + SkipList, %MB_Ok + %MB_IconInformation, "Skip List"
            Else
                MsgBox "Ran out of time. Unable to place " +  Trim$(Str$(i)) + " words in the cloud space!",  %MB_Ok + %MB_IconInformation, "Skip List"
            End If
        Else
            If i < 26 Then  '26 should fit on the screen easily
                MsgBox "These words would not fit in the cloud space:" + $CrLf + $CrLf + SkipList, %MB_Ok + %MB_IconInformation, "Skip List"
            Else
                MsgBox "Several (" + Trim$(Str$(i)) + ") words did not fit in the cloud space!",  %MB_Ok + %MB_IconInformation, "Skip List"
            End If
        End If
    End If
    MousePtr 0
End Sub

Sub RemoveFonts
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    Graphic Attach hDlg, %IDC_Graphic, ReDraw
    Graphic Set Font 0

    For i = CFN.FontSizeMin To CFN.FontSizeMax
        Font End FontsA(i)
        Font End FontsB(i)
        Font End FontsRA(i)
        Font End FontsRB(i)
        Font End FontsRRA(i)
        Font End FontsRRB(i)
    Next i
    Reset FontsA(), FontsB(), FontsRA(), FontsRB(), FontsRRA(), FontsRRB()
End Sub

Sub CreateFonts
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    ReDim FontsA(CFN.FontSizeMin To CFN.FontSizeMax)   'normal
    ReDim FontsB(CFN.FontSizeMin To CFN.FontSizeMax)   'underline
    ReDim FontsRA(CFN.FontSizeMin To CFN.FontSizeMax) 'rotate normal
    ReDim FontsRB(CFN.FontSizeMin To CFN.FontSizeMax)  'rotate underline
    ReDim FontsRRA(CFN.FontSizeMin To CFN.FontSizeMax) 'rotate normal
    ReDim FontsRRB(CFN.FontSizeMin To CFN.FontSizeMax)  'rotate underline
    For i = CFN.FontSizeMin To CFN.FontSizeMax
        Font New Trim$(CFN.FontName), i, CFN.FontBold + CFN.FontItalic * 2 To FontsA(i)
        Font New Trim$(CFN.FontName), i, CFN.FontBold + CFN.FontItalic * 2 + 4 To FontsB(i)
        Font New Trim$(CFN.FontName), i, CFN.FontBold + CFN.FontItalic * 2,1,0,900 To FontsRA(i)
        Font New Trim$(CFN.FontName), i, CFN.FontBold + CFN.FontItalic * 2 + 4,1,0,900 To FontsRB(i)
        Font New Trim$(CFN.FontName), i, CFN.FontBold + CFN.FontItalic * 2,1,0,-900 To FontsRRA(i)
        Font New Trim$(CFN.FontName), i, CFN.FontBold + CFN.FontItalic * 2 + 4,1,0,-900 To FontsRRB(i)
    Next i
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   If Debug Then cPrint LCase$(FuncName$)
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
   If Debug Then cPrint LCase$(FuncName$)
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then cPrint LCase$(FuncName$)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx hHook
   End If
End Function

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hTBContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateTextBoxContextMenu
    If Debug Then cPrint LCase$(FuncName$)
    Menu New PopUp To hTBContext
    Menu Add String, hTBContext, "Cut",    %IDM_EditCut,  %MF_Enabled
    Menu Add String, hTBContext, "Copy",   %IDM_EditCopy,  %MF_Enabled
    Menu Add String, hTBContext, "Paste",  %IDM_EditPaste,  %MF_Enabled
    Menu Add String, hTBContext, "Delete", %IDM_EditDelete,  %MF_Enabled
    Menu Add String, hTBContext, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hTBContext, "Clear All", %IDM_EditClear,  %MF_Enabled
    Menu Add String, hTBContext, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hTBContext, "Replace All With Default Words", %IDM_Sample,    %MF_Enabled
    Menu Add String, hTBContext, "Replace All From Clipboard", %IDM_EditReplace, %MF_Enabled
    Menu Add String, hTBContext, "Get Word List From File ...", %IDM_EditGetFile, %MF_Enabled
    Menu Add String, hTBContext, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hTBContext, "Save Words", %IDM_SaveWords, %MF_Enabled
    Menu Add String, hTBContext, "Restore Words", %IDM_RestoreWords, %MF_Enabled
'    Menu Add String, hTBContext, "Get Word List From URL ...", %IDM_EditGetURL, %MF_Enabled

End Sub

Sub CreateWordContextMenu
    If Debug Then cPrint LCase$(FuncName$)
    Menu New PopUp To hPopupWord
    Menu Add String, hPopupWord, "Information",  %IDM_WordInfo,  %MF_Enabled
    Menu Add String, hPopupWord, "-",            %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupWord, "Set Target",   %IDM_SetTarget,  %MF_Enabled
    Menu Add String, hPopupWord, "Open Target",  %IDM_OpenTarget,  %MF_Enabled
    Menu Add String, hPopupWord, "-",            %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupWord, "Clear Target",   %IDM_ClearTarget,  %MF_Enabled
    Menu Add String, hPopupWord, "Clear All Targets",  %IDM_ClearAllTargets,  %MF_Enabled
    Menu Add String, hPopupWord, "-",            %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupWord, "Remove From Cloud",  %IDM_RemoveWord,  %MF_Enabled
    Menu Add String, hPopupWord, "-",            %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupWord, "Move Up",  %IDM_Up,  %MF_Enabled
    Menu Add String, hPopupWord, "Move Down",  %IDM_Down,  %MF_Enabled
    Menu Add String, hPopupWord, "Move Left",  %IDM_Left,  %MF_Enabled
    Menu Add String, hPopupWord, "Move Right",  %IDM_Right,  %MF_Enabled
    Menu Add String, hPopupWord, "-",            %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupWord, "Change Color",  %IDM_ChangeColor,  %MF_Enabled
    Menu Add String, hPopupWord, "Change Font Size",  %IDM_ChangeFontSize,  %MF_Enabled
    Menu Add String, hPopupWord, "-",            %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupWord, "Rename Word",  %IDM_ChangeText,  %MF_Enabled
    Menu Add String, hPopupWord, "Add Similar Word",  %IDM_AddWord,  %MF_Enabled
    Menu Add String, hPopupWord, "-",            %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopupWord, "Remove Rotation",  %IDM_RotateRemove,  %MF_Enabled
    Menu Add String, hPopupWord, "Set Rotate CCW",  %IDM_RotateCCW,  %MF_Enabled
    Menu Add String, hPopupWord, "Set Rotate CW",  %IDM_RotateCW,  %MF_Enabled
End Sub

Sub CreateImageList
    If Debug Then cPrint LCase$(FuncName$)
    ImageList New Icon 24,24,24,20 To hImageList
    ImageList Add Icon hImageList, "xcreate"      '1
    ImageList Add Icon hImageList, "xfonts"       '2
    ImageList Add Icon hImageList, "xcolors"      '3
    ImageList Add Icon hImageList, "xhelp"        '4
    ImageList Add Icon hImageList, "xsettings"    '5
    ImageList Add Icon hImageList, "xsave"        '6
    ImageList Add Icon hImageList, "xopen"        '7
    ImageList Add Icon hImageList, "xnew"         '8
    ImageList Add Icon hImageList, "xwords"       '9
    ImageList Add Icon hImageList, "ximage"       '10
    ImageList Add Icon hImageList, "xpatterns"       '11
    ImageList Add Icon hImageList, "xlock"       '12
End Sub

Sub CreateToolbar
    If Debug Then cPrint LCase$(FuncName$)
    Local w,h As Long
    Dialog Get Client hDlg To w,h
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0    'attach imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_New,  %TbStyle_Button, "New"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Save,  %TbStyle_Button Or %TbStyle_DropDown, "Save"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Create,  %TbStyle_Button, "Create Cloud"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Patterns,  %TbStyle_Button Or %TbStyle_DropDown, "Patterns"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Words,  %TbStyle_Check Or %TbStyle_DropDown, "Words"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Font,  %TbStyle_Button Or %TbStyle_DropDown, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Image,  %TbStyle_Check Or %TbStyle_DropDown, "Image"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Colors,  %TbStyle_Button Or %TbStyle_DropDown, "Colors"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Lock,  %TbStyle_Check, "Lock"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Help,  %TbStyle_Button Or %TbStyle_DropDown, "Help"
End Sub

Sub CreateToolbarContextMenu
  If Debug Then cPrint LCase$(FuncName$)

  Menu New PopUp To hPopupSymbols

  Menu New PopUp To hPopupHelp
  Menu Add String, hPopupHelp, "Cloud Settings", %IDM_ShowCFN, %MF_Enabled
  Menu Add String, hPopupHelp, "-", %IDM_Sep, %MF_Enabled
  Menu Add String, hPopupHelp, "Visible Word List (Alpha)", %IDM_ShowListAlpha, %MF_Enabled
  Menu Add String, hPopupHelp, "Visible Word List (Freq)", %IDM_ShowList, %MF_Enabled
  Menu Add String, hPopupHelp, "-", %IDM_Sep, %MF_Enabled
  Menu Add String, hPopupHelp, "Complete Word List (Alpha)", %IDM_ShowCListAlpha, %MF_Enabled
  Menu Add String, hPopupHelp, "Complete Word List (Freq)", %IDM_ShowCList, %MF_Enabled
  Menu Add String, hPopupHelp, "-", %IDM_Sep, %MF_Enabled
  Menu Add String, hPopupHelp, "Skipped Word List", %IDM_ShowSkipList, %MF_Enabled
  Menu Add String, hPopupHelp, "Excluded Word List", %IDM_ShowExcluded, %MF_Enabled
  Menu Add String, hPopupHelp, "Infrequent Word List", %IDM_ShowInfrequent, %MF_Enabled
  Menu Add String, hPopupHelp, "Short Word List", %IDM_ShowShort, %MF_Enabled

  Menu New PopUp To hPopupColors
  Menu Add String, hPopupColors, "Background ...", %IDM_ColorBG, %MF_Enabled
  Menu Add String, hPopupColors, "Lowest Frequency Word ...", %IDM_ColorLo, %MF_Enabled
  Menu Add String, hPopupColors, "Highest Frequency Word ...", %IDM_ColorHi, %MF_Enabled
  Menu Add String, hPopupColors, "Custom Color List ...", %IDM_EditColorList, %MF_Enabled
  Menu Add String, hPopupColors, "Mask Exclusion Color ...", %IDM_MaskColor, %MF_Enabled
  Menu Add String, hPopupColors, "-", %IDM_Sep, %MF_Enabled
  Menu Add String, hPopupColors, "Gradient", %IDM_ThemeGradient, %MF_Enabled
  Menu Add String, hPopupColors, "Random", %IDM_ThemeRandom, %MF_Enabled
  Menu Add String, hPopupColors, "Full Spectrum", %IDM_ThemeSpectrum, %MF_Enabled
  Menu Add String, hPopupColors, "Custom List", %IDM_ThemeList, %MF_Enabled

  Menu New PopUp To hPopupSettings
  Menu Add String, hPopupSettings, "Hide TextBox", %IDM_HideText, %MF_Enabled
  Menu Add String, hPopupSettings, "Show File Name in Caption", %IDM_ShowName, %MF_Enabled
  Menu Add String, hPopupSettings, "Time Limit", %IDM_LimitTime, %MF_Enabled

  Menu New PopUp To hPopupPatterns
  Menu Add String, hPopupPatterns, "Random", %IDM_PatternRandom, %MF_Enabled
  Menu Add String, hPopupPatterns, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupPatterns, "Horizontal (Frequency)", %IDM_PatternHorFreq, %MF_Enabled
  Menu Add String, hPopupPatterns, "Horizontal (Random)", %IDM_PatternHorRandom, %MF_Enabled
  Menu Add String, hPopupPatterns, "Horizontal (Length)", %IDM_PatternHorLength, %MF_Enabled
  Menu Add String, hPopupPatterns, "Horizontal (Alpha)", %IDM_PatternHorAlpha, %MF_Enabled
  Menu Add String, hPopupPatterns, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupPatterns, "Mask", %IDM_PatternSymbols, %MF_Enabled
  Menu Add String, hPopupPatterns, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add PopUp,  hPopupPatterns, "Select Mask", hPopupSymbols, %MF_Enabled
  Menu Add String, hPopupPatterns, "Open Mask Folder", %IDM_OpenSymbolFolder, %MF_Enabled

  Menu New PopUp To hPopupFont
  Menu Add String, hPopupFont, "Select Font ...", %IDM_SelectFont, %MF_Enabled
  Menu Add String, hPopupFont, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupFont, "Min Font Size ...", %IDM_FontSizeMin, %MF_Enabled
  Menu Add String, hPopupFont, "Max Font Size ...", %IDM_FontSizeMax, %MF_Enabled
  Menu Add String, hPopupFont, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupFont, "Bold", %IDM_FontBold, %MF_Enabled
  Menu Add String, hPopupFont, "Italic", %IDM_FontItalic, %MF_Enabled
  Menu Add String, hPopupFont, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupFont, "Fixed Font", %IDM_FixedFont, %MF_Enabled
  Menu Add String, hPopupFont, "Fixed Font Size", %IDM_FixedFontSize, %MF_Enabled

  Menu New PopUp To hPopupWords
  Menu Add String, hPopupWords, "Max Words to Display ...", %IDM_MaxWordsToDisplay, %MF_Enabled
  Menu Add String, hPopupWords, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupWords, "Min Word Width ...", %IDM_MinWordWidth, %MF_Enabled
  Menu Add String, hPopupWords, "Minimum Frequency ...", %IDM_LowestAllowedFrequency, %MF_Enabled
  Menu Add String, hPopupWords, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupWords, "Word Margin (Hor) ...", %IDM_WordMarginH, %MF_Enabled
  Menu Add String, hPopupWords, "Word Margin (Vert) ...", %IDM_WordMarginV, %MF_Enabled
  Menu Add String, hPopupWords, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupWords, "Allowed Character List ...", %IDM_CharList, %MF_Enabled
  Menu Add String, hPopupWords, "Excluded Words ...", %IDM_BadWordList, %MF_Enabled
  Menu Add String, hPopupWords, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupWords, "Exclude Selected Words", %IDM_HideBadWords, %MF_Enabled
  Menu Add String, hPopupWords, "Display Frequency", %IDM_ShowFreq, %MF_Enabled
  Menu Add String, hPopupWords, "Allow Rotation", %IDM_Rotation, %MF_Enabled
  Menu Add String, hPopupWords, "Fast Word Removal", %IDM_FastRemoval, %MF_Enabled
  Menu Add String, hPopupWords, "Baseline Alignment (Hor)", %IDM_Baseline, %MF_Enabled

  Menu New PopUp To hPopupImage
  Menu Add String, hPopupImage, "Select Background Image ...", %IDM_SelectImage, %MF_Enabled
  Menu Add String, hPopupImage, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupImage, "Copy Cloud Image To Clipboard", %IDM_CopyImage, %MF_Enabled
  Menu Add String, hPopupImage, "Save Cloud Image To File", %IDM_SaveImage, %MF_Enabled
  Menu Add String, hPopupImage, "-",              %IDM_Sep,    %MF_Enabled
  Menu Add String, hPopupImage, "Display Background Image", %IDM_UseImage, %MF_Enabled
  Menu Add String, hPopupImage, "GrayScale Image", %IDM_GrayScale, %MF_Enabled
  Menu Add String, hPopupImage, "Mask As Background Image", %IDM_UseSymbolAsBG, %MF_Enabled

  Menu New PopUp To hPopupSave
  Menu Add String, hPopupSave, "Save Cloud As ...", %IDM_SaveAs, %MF_Enabled
End Sub

Sub SetLabelColors
    If Debug Then cPrint LCase$(FuncName$)
    Control Set Color hDlg, %IDC_LabelLo, CFN.ColorLo, CFN.ColorLo
    Control Set Color hDlg, %IDC_LabelHi, CFN.ColorHi, CFN.ColorHi
    Control ReDraw hDlg, %IDC_LabelLo
    Control ReDraw hDlg, %IDC_LabelHi
End Sub

Sub BuildInverseCharList
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    InverseCharList = ""
    For i = 33 To 255
        If InStr(CFN.CharList,Chr$(i)) = 0 Then
            InverseCharList = InverseCharList + Chr$(i)
        End If
    Next i
    InverseCharList = InverseCharList + Chr$(08) + Chr$(10) + Chr$(13) + Chr$(0)
End Sub

Sub SetMenuValues
   If Debug Then cPrint LCase$(FuncName$)
   Menu Set Text hPopupWords,    ByCmd %IDM_MinWordWidth, "Min Word Width (" + Trim$(Str$(CFN.MinWordWidth)) + ") ..."
   Menu Set Text hPopupWords,    ByCmd %IDM_MaxWordsToDisplay, "Max Words to Display (" + Trim$(Str$(CFN.MaxWordsToDisplay)) + ") ..."
   Menu Set Text hPopupWords,    ByCmd %IDM_LowestAllowedFrequency, "Minimum Frequency (" + Trim$(Str$(CFN.LowestAllowedFrequency)) + ") ..."
   Menu Set Text hPopupWords,    ByCmd %IDM_WordMarginH, "Word Margin (Hor) (" + Trim$(Str$(CFN.WordMarginH)) + ") ..."
   Menu Set Text hPopupWords,    ByCmd %IDM_WordMarginV, "Word Margin (Vert) (" + Trim$(Str$(CFN.WordMarginV)) + ") ..."
   Menu Set Text hPopupFont,     ByCmd %IDM_FontSizeMin, "Min Font Size (" + Trim$(Str$(CFN.FontSizeMin)) + ") ..."
   Menu Set Text hPopupFont,     ByCmd %IDM_FontSizeMax, "Max Font Size (" + Trim$(Str$(CFN.FontSizeMax)) + ") ..."
   Menu Set Text hPopupFont,     ByCmd %IDM_FixedFontSize, "Fixed Font Size (" + Trim$(Str$(CFN.FixedFontSize)) + ") ..."
   Menu Set Text hPopupPatterns, ByCmd %IDM_PatternSymbols, "Mask (" + Trim$(PathName$(Name,CFN.SymbolName)) + ")"
   Menu Set Text hPopupSettings, ByCmd %IDM_LimitTime, "Time Limit (" + Trim$(MaxTime) + " sec)"
End Sub

Sub ReSizeWindow(Flag As Long)   'flag means adjust dialog size
   If Debug Then cPrint LCase$(FuncName$)
   Local w,h As Long

   Dialog Get Client hDlg To w,h

   SendMessage(hTextIn, %WM_SETREDRAW, 0, 0)  'Turn off redraw for faster and smoother action
   If HideText Then
       Control Show State hDlg, %IDC_TextIn, %SW_Hide
       Control Set Size hDlg, %IDC_TextIn, 0,0         'needed so MoveMove reports hGraphic correctly
       Control Set Loc hDlg, %IDC_Graphic, 10, 50
       Graphic Set Size w-20,h-75
       Control Set Loc hdlg, %IDC_LabelHi, 1, 60
       Control Set Loc hDlg, %IDC_GraphicL,2,70
       Control Set Loc hdlg, %IDC_LabelLo, 1, 173
       If Flag Then h = h - 110 : Dialog Set Client hDlg, w,h
   Else
       Control Show State hDlg, %IDC_TextIn, %SW_Show
       Control Set Size hDlg, %IDC_TextIn, w-20,100
       Control Set Loc hDlg, %IDC_Graphic, 10, 155
       Graphic Set Size w-20,h-180
       Control Set Loc hdlg, %IDC_LabelHi, 1, 160
       Control Set Loc hDlg, %IDC_GraphicL,2,170
       Control Set Loc hdlg, %IDC_LabelLo, 1, 273
       If Flag Then h = h + 110 : Dialog Set Client hDlg, w,h
   End If
   SendMessage hTextIn, %WM_SETREDRAW, 1, 0   'Turn on redraw again and refresh

   'rescale hSymbol to match new size of graphic control
   SetSymbolScale

   'resize hCloud whenever window size changes
   Control Get Client hDlg, %IDC_Graphic To w,h
   Graphic Bitmap New w,h To hCloud

   ReDrawCloud
End Sub

Sub SelectImage
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   title$ = "Open File"
   filter$ = "Images" + $Nul + "*.bmp;*.jpg;*.gif;*.png" + $Nul
   startfolder$ = CFN.CFNImage
   startfile$ = CFN.CFNImage
   defaultext$ = ""
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then CFN.CFNImage = LCase$(filevar$)
End Sub

Sub LoadCFNImage
   If Debug Then cPrint LCase$(FuncName$)
   On Error GoTo LoadError
   Local w,h As Long
   Local pGraphics, pImage, hBMPDC As Dword, strFileName As String
   Local token As Dword, StartupInput As GdiplusStartupInput
   If IsFalse(IsFile(Trim$(CFN.CFNImage))) Then Beep : Exit Sub

   'initialize GDIPlus
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   'load/display image onto Graphic control
   strFileName = UCode$(Trim$(CFN.CFNImage))                         'image source file

   GdipLoadImageFromFile(StrPtr(strFileName), pImage)  'pImage - image object
   GdipGetImageWidth(pImage,ImgW)
   GdipGetImageHeight(pImage,ImgH)

   'place to put the image
   If hBMP Then Graphic Attach hBMP, 0 : Graphic Bitmap End : hBMP = 0
   Graphic Bitmap New ImgW,ImgH To hBMP
   Graphic Attach hBMP, 0
   Graphic Get DC To hBMPDC

   GdipCreateFromHDC(hBMPDC, pGraphics)                    'pGraphics - graphic object
   GdipDrawImageRectI pGraphics, pImage, 0, 0, ImgW, ImgH  'draw on graphic object - hBMP now contains image from file

   'cleanup
   If pImage Then GdipDisposeImage(pImage)         'delete image object
   If pGraphics Then GdipDeleteGraphics(pGraphics) 'delete graphic object
   GdiplusShutdown token                           ' Shutdown GDI+

   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Control Get Client hDlg, %IDC_Graphic To w,h

   Exit Sub
LoadError:
   MsgBoxX "Error loading image: " + Str$(Err) + $CrLf + Error$(Err), %MB_Ok + %MB_IconExclamation, "Image Load Error"
End Sub

Sub GetBadWordList
    If Debug Then cPrint LCase$(FuncName$)
    Open Exe.Path$ + "temp\exclude.txt" For Binary As #1
    Get$ #1, Lof(1), BadWordList
    Close #1
    Replace $CrLf With " " In BadWordList
    BadWordList = " " + LCase$(BadWordList) + " "
    BadWordList = " " + Shrink$(LCase$(BadWordList)) + " "
End Sub

Sub DrawNew(iPos As Long)
    If Debug Then cPrint LCase$(FuncName$)
    'kill hCopy if it exists
    If hCopy Then Graphic Attach hCopy,0 : Graphic Bitmap End : hCopy = 0
    'create new hCopy (bitmap of word before it is underlined)
    Graphic Bitmap New CFN.CWords(iPos).rc.nRight-CFN.CWords(iPos).rc.nLeft,CFN.CWords(iPos).rc.nBottom-CFN.CWords(iPos).rc.nTop To hCopy
    Graphic Attach hCopy, 0
    Graphic Copy hDlg, %IDC_Graphic, (CFN.CWords(iPos).rc.nLeft,CFN.CWords(iPos).rc.nTop)-(CFN.CWords(iPos).rc.nRight,CFN.CWords(iPos).rc.nBottom) To (0,0)
    'draw word with underline
    Graphic Attach hDlg, %IDC_Graphic, ReDraw
    If CFN.Rotation And (CFN.CWords(iPos).rot=6) Then
        Graphic Set Font FontsRRB(CFN.CWords(iPos).FontSize)
        Graphic Set Pos (CFN.CWords(iPos).rc.nRight-CFN.WordMarginH,CFN.CWords(iPos).rc.nTop+CFN.WordMarginV)
    ElseIf CFN.Rotation And (CFN.CWords(iPos).rot=5) Then
        Graphic Set Font FontsRB(CFN.CWords(iPos).FontSize)
        Graphic Set Pos (CFN.CWords(iPos).rc.nLeft+CFN.WordMarginH,CFN.CWords(iPos).rc.nBottom-CFN.WordMarginV)
    Else
        Graphic Set Font FontsB(CFN.CWords(iPos).FontSize)
        Graphic Set Pos (CFN.CWords(iPos).rc.nLeft+CFN.WordMarginH,CFN.CWords(iPos).rc.nTop+CFN.WordMarginV)
    End If
    Graphic Color CFN.CWords(iPos).RGB, -2  'API are zero-based
    Graphic Print Trim$(CFN.CWords(iPos).Text)
    Graphic ReDraw
End Sub

Sub Settings_INI(Task$)
   If Debug Then cPrint LCase$(FuncName$)
   Local i,x,y As Long
   Local xResult, yResult, tempz, INIFileName As AsciiZ * %Max_Path

   'set ini filename
   INIFileName = Exe.Path$ + "temp\gbcloud.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "690", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "650", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for string variables
      GetPrivateProfileString "All", "CFNname", Exe.Path$ + "temp\default.gbc", tempz, %Max_Path, INIFileName
      CFNname = LCase$(tempz)

      GetPrivateProfileString "All", "LastURL", Exe.Path$ + "http://www.garybeene.com/gbcloud.htm", tempz, %Max_Path, INIFileName
      LastURL = LCase$(tempz)

      GetPrivateProfileString "All", "SessionFile", Exe.Path$ + "temp\session.gbc", tempz, %Max_Path, INIFileName
      SessionFile = LCase$(tempz)

      GetPrivateProfileString "All", "NewContent", "gbCloud", tempz, %Max_Path, INIFileName
      NewContent = LCase$(tempz)

      'get value for numeric variables
      Getprivateprofilestring "All", "Debug", "0", tempz, %Max_Path, INIFileName
      Debug = Val(tempz)

      Getprivateprofilestring "All", "MaxIterations", "100000", tempz, %Max_Path, INIFileName
      MaxIterations = Val(tempz)

      Getprivateprofilestring "All", "LimitTime", "1", tempz, %Max_Path, INIFileName
      LimitTime = Val(tempz)

      Getprivateprofilestring "All", "MaxTime", "7", tempz, %Max_Path, INIFileName
      MaxTime = Val(tempz)

      Getprivateprofilestring "All", "HideText", "0", tempz, %Max_Path, INIFileName
      HideText = Val(tempz)

      Getprivateprofilestring "All", "ShowName", "0", tempz, %Max_Path, INIFileName
      ShowName = Val(tempz)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(tempz)
      Next i

   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "CFNname", (CFNname), INIFileName
      WritePrivateProfileString "All", "LastURL", (LastURl), INIFileName
      WritePrivateProfileString "All", "SessionFile", (SessionFile), INIFileName
      WritePrivateProfileString "All", "NewContent", (NewContent), INIFileName
      'save numeric variable
      WritePrivateProfileString "All", "Debug", (Str$(Debug)), INIFileName
      WritePrivateProfileString "All", "MaxIterations", (Str$(MaxIterations)), INIFileName
      WritePrivateProfileString "All", "LimitTime", (Str$(LimitTime)), INIFileName
      WritePrivateProfileString "All", "MaxTime", (Str$(MaxTime)), INIFileName
      WritePrivateProfileString "All", "HideText", (Str$(HideText)), INIFileName
      WritePrivateProfileString "All", "ShowName", (Str$(ShowName)), INIFileName

      For i = 0 To 15
         tempz = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(i,"00"), tempz, INIFileName
      Next i
   End If
End Sub

Sub SetPopupMenuStates
     If Debug Then cPrint LCase$(FuncName$)
     Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Image, %TBState_Checked * CFN.UseBGImage Or %TBState_Enabled
     Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Words, %TBState_Checked * CFN.ShowFrequency Or %TBState_Enabled
     Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Lock, %TBState_Checked * CFN.Lock Or %TBState_Enabled

     Menu Set State hPopupSettings, ByCmd %IDM_HideText, HideText * 8
     Menu Set State hPopupSettings, ByCmd %IDM_ShowName, ShowName * 8
     Menu Set State hPopupSettings, ByCmd %IDM_LimitTime, LimitTime * 8

     Menu Set State hPopupWords, ByCmd %IDM_HideBadWords, CFN.HideBadWords * 8
     Menu Set State hPopupWords, ByCmd %IDM_ShowFreq, CFN.ShowFrequency * 8
     Menu Set State hPopupWords, ByCmd %IDM_Rotation, CFN.Rotation * 8
     Menu Set State hPopupWords, ByCmd %IDM_FastRemoval, CFN.FastRemoval * 8

     Menu Set State hPopupImage, ByCmd %IDM_UseImage, CFN.UseBGImage * 8
     Menu Set State hPopupimage, ByCmd %IDM_GrayScale, CFN.GrayScale * 8
     Menu Set State hPopupImage, ByCmd %IDM_UseSymbolAsBG, CFN.UseSymbolAsBG * 8

     Menu Set State hPopupFont, ByCmd %IDM_FontBold, CFN.FontBold * 8
     Menu Set State hPopupFont, ByCmd %IDM_FontItalic, CFN.FontItalic * 8
     Menu Set State hPopupFont, ByCmd %IDM_FixedFont, CFN.FixedFont * 8

     Menu Set State hPopupColors, ByCmd %IDM_ThemeGradient, 0
     Menu Set State hPopupColors, ByCmd %IDM_ThemeRandom, 0
     Menu Set State hPopupColors, ByCmd %IDM_ThemeSpectrum, 0
     Menu Set State hPopupColors, ByCmd %IDM_ThemeList, 0
     Select Case CFN.ThemeColor
         Case %ThemeGradient : Menu Set State hPopupColors, ByCmd %IDM_ThemeGradient, 8
         Case %ThemeRandom   : Menu Set State hPopupColors, ByCmd %IDM_ThemeRandom, 8
         Case %ThemeSpectrum : Menu Set State hPopupColors, ByCmd %IDM_ThemeSpectrum, 8
         Case %ThemeList     : Menu Set State hPopupColors, ByCmd %IDM_ThemeList, 8
     End Select

     Menu Set State hPopupWords, ByCmd %IDM_Baseline, CFN.Baseline * 8

     Menu Set State hPopupPatterns, ByCmd %IDM_PatternRandom, 0
     Menu Set State hPopupPatterns, ByCmd %IDM_PatternHorFreq, 0
     Menu Set State hPopupPatterns, ByCmd %IDM_PatternHorRandom, 0
     Menu Set State hPopupPatterns, ByCmd %IDM_PatternHorLength, 0
     Menu Set State hPopupPatterns, ByCmd %IDM_PatternHorAlpha, 0
     Menu Set State hPopupPatterns, ByCmd %IDM_PatternSymbols, 0
     Select Case CFN.Patterns
         Case %PosRandom     : Menu Set State hPopupPatterns, ByCmd %IDM_PatternRandom, 8
         Case %PosHorFreq    : Menu Set State hPopupPatterns, ByCmd %IDM_PatternHorFreq, 8
         Case %PosHorRandom  : Menu Set State hPopupPatterns, ByCmd %IDM_PatternHorRandom, 8
         Case %PosHorLength  : Menu Set State hPopupPatterns, ByCmd %IDM_PatternHorLength, 8
         Case %PosHorAlpha   : Menu Set State hPopupPatterns, ByCmd %IDM_PatternHorAlpha, 8
         Case %PosSymbols    : Menu Set State hPopupPatterns, ByCmd %IDM_PatternSymbols, 8
     End Select

     If CFN.ThemeColor = %ThemeGradient Then
         Control Show State hDlg, %IDC_LabelHi, %SW_Show
         Control Show State hDlg, %IDC_LabelLo, %SW_Show
         Control Show State hDlg, %IDC_GraphicL, %SW_Show
     Else
         Control Show State hDlg, %IDC_LabelHi, %SW_Hide
         Control Show State hDlg, %IDC_LabelLo, %SW_Hide
         Control Show State hDlg, %IDC_GraphicL, %SW_Hide
     End If

End Sub

Sub CreateSubFolders
   If Debug Then cPrint LCase$(FuncName$)
   If IsFolder (Exe.Path$ + "temp") = %False Then MkDir Exe.Path$ + "temp"
   If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
   If IsFolder (Exe.Path$ + "masks") = %False Then MkDir Exe.Path$ + "masks"
End Sub

Sub SaveCFN
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$
    Control Get Text hDlg, %IDC_TextIn To temp$
    Open CFNName For Binary As #1
    Put #1,,CFN     '260 bytes - the number of array elements
    Put #1,,temp$
    Close #1
End Sub

Sub SaveAs
    If Debug Then cPrint LCase$(FuncName$)
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""             'caption title. if "", then "Save As" is displayed
    startfolder$ = CFNname   'initial folder to be displayed
    filter$ = "Cloud Data (*.gbc)" + $Nul + "*.gbc" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfile$ = CFNname        'name to be used as initial selection
    defaultext$ = "gbc"     'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then CFNname = filevar$ : SetCaption : SaveCFN   'ESC stops saving action
End Sub

Sub SelectCFN
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   title$ = "Open Cloud"
   filter$ = "Cloud Data (*.gbc)" + $Nul + "*.gbc" + $Nul
   startfolder$ = CFNname
   startfile$ = CFNname
   defaultext$ = "gbc"
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then CFNname = filevar$ : SetCaption : OpenCFN
End Sub

Sub OpenCFN
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$
    Open CFNname For Binary As #1
    Get #1,,CFN
    temp$ = Space$(Lof(1)-Seek(1))
    Get #1,,temp$
    Close #1
    Control Get Text hDlg, %IDC_TextIn To temp$
End Sub

Sub SaveSession
   If Debug Then cPrint LCase$(FuncName$)
   On Error GoTo SaveError
   Local temp$
   CreateSubFolders
   Control Get Text hDlg, %IDC_TextIn To temp$
   If IsFile(Trim$(SessionFile)) Then Kill SessionFile
   Open SessionFile For Binary As #1
   Put #1,,CFN     'All Settings + CWords
   Put #1,,temp$
   Close #1
   Exit Sub
SaveError:
   MsgBoxX "Error saving session!", %MB_Ok + %MB_IconExclamation, "Save Session"
End Sub

Sub RestoreSession
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$
   If IsFile(Trim$(SessionFile)) Then
       Open SessionFile For Binary As #1
       Get #1,,CFN
       temp$ = Space$(Lof(1)-Seek(1)+1)
       Get #1,,temp$
       Close #1
       Control Set Text hDlg, %IDC_TextIn, temp$
   Else
       CFNname = Exe.Path$ + "temp\default.gbc"
       SetCFNToDefaultValues
       Control Set Text hDlg, %IDC_TextIn, SampleContent
   End If
   SetCaption
End Sub

Sub SetCFNToDefaultValues
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    Reset CFN
    For i = 0 To %CWordLimit : CFN.CWords(i).Text = "" : CFN.CWords(i).target = "" : Next i
    CFN.CFNImage = Exe.Path$ + "files\gbclouds.jpg"
    CFN.CharList = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_"
    CFN.FontName = "Cooper Black"
    CFN.SymbolName = Exe.Path$ + "masks\circle.bmp"
    CFN.Res01 = ""
    CFN.Res02 = ""
    CFN.LowestAllowedFrequency = 1
    CFN.HideBadWords = 0
    CFN.FontItalic = 0
    CFN.FontBold = 1
    CFN.ColorHi = %DefaultHiColor
    CFN.ColorLo = %DefaultLoColor
    CFN.ColorBG = %DefaultBGColor
    CFN.MinWordWidth = 2
    CFN.MaxWordsToDisplay = 99
    CFN.Rotation = 0
    CFN.ShowFrequency = 0
    CFN.FontSizeMin = 8
    CFN.FontSizeMax = 48
    CFN.MaxFreq = 1
    CFN.MinFreq = 1
    CFN.UseBGImage = 1
    CFN.MaxCWords = 0
    CFN.GrayScale = 0
    CFN.ThemeColor = %ThemeGradient
    CFN.WordMarginH= 5
    CFN.WordMarginV= 0
    CFN.DrawBoundary = 0
    CFN.Patterns = %PosRandom
    CFN.EdgeMargin = 10
    CFN.UseSymbolAsBG = 0
    CFN.MaskColor = %White
    CFN.FastRemoval = 0
    CFN.FixedFont = 0
    CFN.FixedFontSize = 18
    CFN.FixedColor = -1
    CFN.Lock = 0
    CFN.Colors(0) = %ListColor00  'Val("&H0000CC")
    CFN.Colors(1) = %ListColor01  'Val("&HOB94FB")
    CFN.Colors(2) = %ListColor02  'Val("&H00FFFF")
    CFN.Colors(3) = %ListColor03  'Val("&H00CC00")
    CFN.Colors(4) = %ListColor04  'Val("&HC60003")
    CFN.Colors(5) = %ListColor05  'Val("&HFF0000")
    CFN.Colors(6) = %ListColor06  'Val("&HA72C76")
    CFN.Colors(7) = %ListColor07  'Val("&HBF98FF")
    CFN.Colors(8) = %ListColor08  'Val("&H999999")
    CFN.Colors(9) = %ListColor09  'Val("&H000000")
'    CFN.Colors(10)= Val("&H185488")
End Sub

Sub CreateExcludeList
    If Debug Then cPrint LCase$(FuncName$)
    If IsFile(Exe.Path$ + "temp\exclude.txt") Then Exit Sub
    Open Exe.Path$ + "temp\exclude.txt" For Output As #1
    Print #1, "a" + $CrLf + "an" + $CrLf + "and" + $CrLf + "if" + $CrLf + "of" + $CrLf +"for"
    Close #1
End Sub

Sub DisplayCFN
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$
    temp$ = "Background Image " + CFN.CFNImage
    temp$ = temp$ + $CrLf + "Allowed Character List:  " + CFN.CharList
    temp$ = temp$ + $CrLf + "Mask Name:  " + CFN.SymbolName
    temp$ = temp$ + $CrLf + "Font Name:  " + CFN.FontName
    temp$ = temp$ + $CrLf + "Lowest Allowed Frequency " + Str$(CFN.LowestAllowedFrequency)
    temp$ = temp$ + $CrLf + "Hide Excluded Words " + Str$(CFN.HideBadWords)
    temp$ = temp$ + $CrLf + "Font Italic " + Str$(CFN.FontItalic)
    temp$ = temp$ + $CrLf + "Font Bold " + Str$(CFN.FontBold)
    temp$ = temp$ + $CrLf + "ColorHi " + Str$(CFN.ColorHi)
    temp$ = temp$ + $CrLf + "ColorLo " + Str$(CFN.ColorLo)
    temp$ = temp$ + $CrLf + "ColorBG " + Str$(CFN.ColorBG)
    temp$ = temp$ + $CrLf + "Min Word Width " + Str$(CFN.MinWordWidth)
    temp$ = temp$ + $CrLf + "Max Word Count " + Str$(CFN.MaxWordsToDisplay)
    temp$ = temp$ + $CrLf + "Rotation " + Str$(CFN.Rotation)
    temp$ = temp$ + $CrLf + "Show Frequency " + Str$(CFN.ShowFrequency)
    temp$ = temp$ + $CrLf + "FontSize Min " + Str$(CFN.FontSizeMin)
    temp$ = temp$ + $CrLf + "FontSize Max " + Str$(CFN.FontSizeMax)
    temp$ = temp$ + $CrLf + "Max Freq " + Str$(CFN.MaxFreq)
    temp$ = temp$ + $CrLf + "Min Freq " + Str$(CFN.MinFreq)
    temp$ = temp$ + $CrLf + "Use BG Image " + Str$(CFN.UseBGImage)
    temp$ = temp$ + $CrLf + "Max CWords " + Str$(CFN.MaxCWords)
    temp$ = temp$ + $CrLf + "GrayScale " + Str$(CFN.GrayScale)
    temp$ = temp$ + $CrLf + "Theme Color " + Str$(CFN.ThemeColor)
    temp$ = temp$ + $CrLf + "Word Margin (Hor)" + Str$(CFN.WordMarginH)
    temp$ = temp$ + $CrLf + "Word Margin (Vert) " + Str$(CFN.WordMarginV)
    temp$ = temp$ + $CrLf + "Draw Boundary " + Str$(CFN.DrawBoundary)
    temp$ = temp$ + $CrLf + "Color List " + Str$(CFN.ColorList)
    temp$ = temp$ + $CrLf + "Patterns " + Str$(CFN.Patterns)
    temp$ = temp$ + $CrLf + "Edge Margin " + Str$(CFN.EdgeMargin)
    temp$ = temp$ + $CrLf + "Baseline " + Str$(CFN.Baseline)
    temp$ = temp$ + $CrLf + "Mask As BG Image " + Str$(CFN.UseSymbolAsBG)
    temp$ = temp$ + $CrLf + "Words in Source " + Str$(CFN.WordsInSource)
    temp$ = temp$ + $CrLf + "Unique Words in Source " + Str$(CFN.UniqueWordsInSource)
    temp$ = temp$ + $CrLf + "Visible Words " + Str$(CFN.VisibleWords)
    temp$ = temp$ + $CrLf + "MaskColor " + Str$(CFN.MaskColor) + Str$(GetRValue(CFN.MaskColor))+ Str$(GetBValue(CFN.MaskColor))+ Str$(GetBValue(CFN.MaskColor))
    temp$ = temp$ + $CrLf + "Fast Removal " + Str$(CFN.FastRemoval)
    temp$ = temp$ + $CrLf + "Fixed Font " + Str$(CFN.FixedFont)
    temp$ = temp$ + $CrLf + "Fixed Font Size " + Str$(CFN.FixedFontSize)
    temp$ = temp$ + $CrLf + "Cloud Lock " + Str$(CFN.Lock)
    temp$ = temp$ + $CrLf + "Manual Color " + Str$(CFN.FixedColor)

    MsgBoxX temp$, %MB_Ok + %MB_IconInformation, "Display Cloud Settings"
End Sub

Sub SetCaption
    If Debug Then cPrint LCase$(FuncName$)
    If ShowName Then
        Dialog Set Text hDlg, "gbCloud " + $ver + "   " + CFNname
    Else
        Dialog Set Text hDlg, "gbCloud " + $ver
    End If
End Sub

Sub OpenTextFile
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, temp$
   title$ = "Open Cloud"
   filter$ = "Text Files" + $Nul + "*.txt;*.bas;*.inc" + $Nul
   startfolder$ = CFNname
   startfile$ = CFNname
   defaultext$ = "txt"
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then
       Open filevar$ For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       Control Set Text hDlg, %IDC_TextIn, temp$
   End If
End Sub

Sub GetURLText(URL$)
    If Debug Then cPrint LCase$(FuncName$)
    Local URLPath As AsciiZ*%Max_Path, LocalPath As AsciiZ*%Max_Path, temp$
    URLPath = URL$
    LocalPath = Exe.Path$ + "temp\contenturl.txt"
    If IsFile(LocalPath) Then Kill LocalPath
    DeleteURLCacheEntry(URLPath)     '1 = success  clear the cache
    If URLDownloadToFile (ByVal 0, URLPath, LocalPath, 0, 0) = 0 Then
       Open LocalPath For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       Control Set Text hDlg, %IDC_TextIn, temp$
    Else
       MsgBox "URL not found!", %MB_Ok Or %MB_IconExclamation, "Get URL Text"
    End If
End Sub

Sub CreateGrayImage
    If Debug Then cPrint LCase$(FuncName$)
    'uses LONG pointer/CVL solution
    Local w,h,i,iColor,r,g,b As Long, p As Long Ptr, bmp$
    Graphic Get Bits To bmp$
    'get width/height of image
    w = Cvl(bmp$,1)
    h = Cvl(bmp$,5)
    p = StrPtr(bmp$)+8    'position of starting position for bits in string
    For i = 1 To w*h
       iColor = @p                           'result is a BGR color value 0-R-G-B
       B = iColor Mod 256                    'or this: iColor AND &HFF&
       G = (iColor\256) Mod 256              'or this: (iColor AND &HFF00&) \ &H100
       R = (iColor\256\256) Mod 256          'or this: (iColor AND &HFF0000&) \ &H10000&
       iColor = 0.299*R + 0.587*G + 0.114*B  'or this: iColor = (R+G+B)/3
       iColor = (255-iColor)*0.4 + iColor
       @p = Bgr(iColor, iColor, iColor)           'modify string at that position
       Incr p
    Next i
    Graphic Set Bits bmp$
End Sub

Sub ShowWordInfo
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, tmp$
    If CFN.CWords(CValue).manualRGB = -1 Then
        tmp$ = "Not assigned"
    Else
        tmp$ = Str$(GetRValue(CFN.CWords(CValue).manualRGB))+ Str$(GetBValue(CFN.CWords(CValue).manualRGB))+ Str$(GetBValue(CFN.CWords(CValue).manualRGB))
    End If

    temp$ = "Word:    "  + Trim$(CFN.CWords(CValue).Text) +  $CrLf + $CrLf + "Freqency: " + Str$(CFN.CWords(CValue).freq) + $CrLf _
           + "Font Size:  " + Str$(CFN.CWords(CValue).FontSize) + $CrLf _
           + "Rotation: " + Choose$(CFN.CWords(CValue).rot+1,"None","None","None","None","CCW","CW") + $CrLf _
           + "RGB:  " + Str$(GetRValue(CFN.CWords(CValue).RGB))+ Str$(GetBValue(CFN.CWords(CValue).RGB))+ Str$(GetBValue(CFN.CWords(CValue).RGB)) + $CrLf _
           + "Manual RGB:  " + tmp$ + $CrLf _
           + "Target:  " + IIf$(Len(Trim$(CFN.CWords(CValue).target)),CFN.CWords(CValue).target,"<no target>")
    MsgBoxX temp$, %MB_Ok+%MB_IconInformation,"Word Information"
End Sub

Sub SelectMainFont
     If Debug Then cPrint LCase$(FuncName$)
     Dialog New Pixels, hDlg, "Select Font", 100, 100, 200, 300, %WS_SysMenu To hFontDialog
     Dialog Set Icon hFontDialog, "aaa"
     Control Add ListBox, hFontDialog, %IDC_ListBox, , 0, 0, 200, 310, %LBS_NoIntegralHeight Or %LBS_Sort Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
     Dialog Show Modal hFontDialog Call FontProc()
End Sub

CallBack Function FontProc() As Long
    Select Case Cb.Msg
       Case %WM_InitDialog
           EnumerateFonts
       Case %WM_Command
           Select Case Cb.Ctl        'GetDlgCtrlID(CB.wParam)
               Case %IDC_ListBox
                   Select Case Cb.CtlMsg   'Lo(Word,wParam)
                       Case %CBN_DblClk
                           ListBox Get Text hFontDialog, %IDC_ListBox To CFN.FontName
                           Dialog End hFontDialog
                   End Select
           End Select
       Case %WM_Destroy
   End Select
End Function

Sub EnumerateFonts
    If Debug Then cPrint LCase$(FuncName$)
    'put list of font names into ListBox
    Local hDC,hTemp As Dword
    hDC = GetDC(%HWND_Desktop)
    hTemp = GetDlgItem(hFontDialog, %IDC_ListBox)
    EnumFontFamilies hDC, ByVal %NULL, CodePtr(EnumFontName), ByVal VarPtr(hTemp)
    ReleaseDC %HWND_Desktop, hDC
End Sub

Function EnumFontName(lf As LOGFONT, tm As TEXTMETRIC, ByVal FontType As Long, hWnd As Dword) As Long
  If (FontType And %TRUETYPE_FONTTYPE) And (Left$(lf.lfFaceName,1)<>"@") Then        ' true type fonts
      ListBox Add hFontDialog, %IDC_ListBox, lf.lfFaceName
  End If
  Function = 1
End Function

Sub EditColorList
     If Debug Then cPrint LCase$(FuncName$)
     Local i As Long
     Dialog New Pixels, hDlg, "Color List Selection", 100, 100, 220, 55, %WS_SysMenu To hColorDialog
     Control Add Button, hColorDialog, %IDC_Default, "Defaults", 145,10,60,25
     Dialog Set Icon hColorDialog, "aaa"
     For i = 0 To 4
         Control Add Label, hColorDialog, %IDC_ColorLabel + i, "", 10+i*25,10,15,10, %SS_Notify
     Next i
     For i = 5 To 9
         Control Add Label, hColorDialog, %IDC_ColorLabel + i, "", 10+(i-5)*25,30,15,10, %SS_Notify
     Next i
     Dialog Show Modal hColorDialog Call ColorProc()
End Sub

CallBack Function ColorProc() As Long
    Local i As Long
    Dim ColorList(9) As Static Long
    Select Case Cb.Msg
       Case %WM_InitDialog
           ColorChange = 0
           For i = 0 To 9
               ColorList(i) = CFN.Colors(i)
               Control Set Color hColorDialog, %IDC_ColorLabel+i, CFN.Colors(i), CFN.Colors(i)
           Next i
       Case %WM_Command
           Select Case Cb.Ctl        'GetDlgCtrlID(CB.wParam)
               Case %IDC_Default
                   ColorList(0) = %ListColor00 :  Control Set Color hColorDialog, %IDC_ColorLabel+0, ColorList(0), ColorList(0) : Control ReDraw hColorDialog, %IDC_ColorLabel+0
                   ColorList(1) = %ListColor01 :  Control Set Color hColorDialog, %IDC_ColorLabel+1, ColorList(1), ColorList(1) : Control ReDraw hColorDialog, %IDC_ColorLabel+1
                   ColorList(2) = %ListColor02 :  Control Set Color hColorDialog, %IDC_ColorLabel+2, ColorList(2), ColorList(2) : Control ReDraw hColorDialog, %IDC_ColorLabel+2
                   ColorList(3) = %ListColor03 :  Control Set Color hColorDialog, %IDC_ColorLabel+3, ColorList(3), ColorList(3) : Control ReDraw hColorDialog, %IDC_ColorLabel+3
                   ColorList(4) = %ListColor04 :  Control Set Color hColorDialog, %IDC_ColorLabel+4, ColorList(4), ColorList(4) : Control ReDraw hColorDialog, %IDC_ColorLabel+4
                   ColorList(5) = %ListColor05 :  Control Set Color hColorDialog, %IDC_ColorLabel+5, ColorList(5), ColorList(5) : Control ReDraw hColorDialog, %IDC_ColorLabel+5
                   ColorList(6) = %ListColor06 :  Control Set Color hColorDialog, %IDC_ColorLabel+6, ColorList(6), ColorList(6) : Control ReDraw hColorDialog, %IDC_ColorLabel+6
                   ColorList(7) = %ListColor07 :  Control Set Color hColorDialog, %IDC_ColorLabel+7, ColorList(7), ColorList(7) : Control ReDraw hColorDialog, %IDC_ColorLabel+7
                   ColorList(8) = %ListColor08 :  Control Set Color hColorDialog, %IDC_ColorLabel+8, ColorList(8), ColorList(8) : Control ReDraw hColorDialog, %IDC_ColorLabel+8
                   ColorList(9) = %ListColor09 :  Control Set Color hColorDialog, %IDC_ColorLabel+9, ColorList(9), ColorList(9) : Control ReDraw hColorDialog, %IDC_ColorLabel+9
                   ColorChange = 1
               Case %IDC_ColorLabel To %IDC_ColorLabel+9
                   Select Case Cb.CtlMsg
                       Case %STN_Clicked
                           i = Cb.Ctl - %IDC_ColorLabel
                           ColorList(i) = SelectColor(i)
                           Control Set Color hColorDialog, Cb.Ctl, ColorList(i), ColorList(i)
                           Control ReDraw hColorDialog, Cb.Ctl
                           ColorChange = 1
                   End Select
           End Select
       Case %WM_SysCommand
           If (Cb.WParam And &HFFF0) = %SC_Close Then    'trap Alt-F4, X-button, WindowMenu/Close
               If ColorChange Then
                   Select Case MsgBoxX("Save changes?",  %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save Changes")
                       Case %IdYes
                           'save colors to CFN.Colors()
                           For i = 0 To 9
                               CFN.Colors(i) = ColorList(i)
                           Next i
                           ReDrawCloud
                       Case %IdCancel
                           Function = 1  'stay in the color dialog
                       Case %IdNo
                           'no action - go ahead and close
                   End Select
               End If
           End If
   End Select
End Function

Sub CPrint (SOut As String)
   Static cWritten As Long, iMsgCount As Long
   Incr iMsgCount
   SOut = Str$(iMsgCount) + " " + SOut
   If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
   WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
End Sub

Function CustomFrequencySort(A As CWord, B As CWord) As Long
    ' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
    Select Case A.freq
        Case > B.freq
            Function = -1
        Case = B.freq
            Function = IIf(A.text < B.text,-1,+1)
        Case Else
            Function = 1
    End Select
End Function

Function CustomLengthSort(A As CWord, B As CWord) As Long
    ' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
    Select Case Len(Trim$(A.text))
        Case > Len(Trim$(B.text))
            Function = -1
        Case = Len(Trim$(B.text))
            Function = IIf(A.text < B.text,-1,+1)
        Case Else
            Function = 1
    End Select
End Function

Function CustomAlphaSort(A As CWord, B As CWord) As Long
    ' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
    Function = IIf(A.text < B.text,-1,+1)
End Function

Sub SetHorizontalPositions
    If Debug Then cPrint LCase$(FuncName$)
    Local yTop,tempH,lStart,i,j,w,h,xPos,hMax,gW,gH,maxTMD As Long, hDC As Dword, TM As TextMetric
    'sort per settings)
    Select Case CFN.Patterns
        Case %PosHorFreq
            ReDim XWord(1 To CFN.MaxCWords) As CWord At VarPtr(CFN.CWords(1))
            Array Sort XWord(), Call CustomFrequencySort()
        Case %PosHorRandom
            For i = 1 To CFN.MaxCWords
                j = Rnd(1,CFN.MaxCWords)
                Swap CFN.CWords(i), CFN.CWords(j)
            Next i
        Case %PosHorLength
            ReDim XWord(1 To CFN.MaxCWords) As CWord At VarPtr(CFN.CWords(1))
            Array Sort XWord(), Call CustomLengthSort()
        Case %PosHorAlpha
            ReDim XWord(1 To CFN.MaxCWords) As CWord At VarPtr(CFN.CWords(1))
            Array Sort XWord(), Call CustomAlphaSort()
    End Select

    'set positions
    SkipList = ""
    Graphic Get DC To hDC
    Control Get Client hDlg, %IDC_Graphic To gW,gH
    yTop  = 0 : xPos  = CFN.EdgeMargin
    For i = 1 To CFN.MaxCWords
       'get parameters for calculations
       Graphic Set Font FontsRA(CFN.CWords(i).FontSize)
       Graphic Text Size Trim$(CFN.CWords(i).Text) To w,h
       GetTextMetrics hDC, TM
       CFN.CWords(i).tmDescent = TM.tmDescent
       If (xPos+w+2*CFN.WordMarginH) > (gW-CFN.EdgeMargin) Then
           'reached end of line. all words are currently aligned at top of line
           'no go back to first word in line apply center/baseline to all words in the line
           For j = lStart To i-1
               If CFN.Baseline Then
                   'baseline
                   tempH = CFN.CWords(j).rc.nBottom - CFN.CWords(j).rc.nTop
                   CFN.CWords(j).rc.nTop = CFN.CWords(j).rc.nTop + (hMax-tempH) + CFN.EdgeMargin - (MaxTMD - CFN.CWords(j).tmDescent)
                   CFN.CWords(j).rc.nBottom = CFN.CWords(j).rc.nTop + tempH
               Else
                   'center
                   tempH = CFN.CWords(j).rc.nBottom - CFN.CWords(j).rc.nTop
                   CFN.CWords(j).rc.nTop = CFN.CWords(j).rc.nTop + (hMax-tempH)/2 + CFN.EdgeMargin
                   CFN.CWords(j).rc.nBottom = CFN.CWords(j).rc.nTop + tempH
               End If
           Next i
           'start of new line
           maxTMD = CFN.CWords(i).tmDescent
           xPos = CFN.EdgeMargin
           yTop = yTop + hMax
           hMax = h+2*CFN.WordMarginV
           lStart = i
       Else
           hMax = Max(h+2*CFN.WordMarginV,hMax)
           maxTMD = Max(CFN.CWords(i).tmDescent,maxTMD)
       End If
       CFN.CWords(i).rc.nLeft = xPos
       CFN.CWords(i).rc.nTop = yTop
       CFN.CWords(i).rc.nRight = xPos + w + 2*CFN.WordMarginH
       CFN.CWords(i).rc.nBottom = yTop + h + 2*CFN.WordMarginV
       xPos = CFN.CWords(i).rc.nRight
    Next i
    'last line
    For j = lStart To i-1
        If CFN.Baseline Then
            'baseline
            tempH = CFN.CWords(j).rc.nBottom - CFN.CWords(j).rc.nTop
            CFN.CWords(j).rc.nTop = CFN.CWords(j).rc.nTop + (hMax-tempH) + CFN.EdgeMargin  - (MaxTMD - CFN.CWords(j).tmDescent)
            CFN.CWords(j).rc.nBottom = CFN.CWords(j).rc.nTop + tempH
        Else
            'center
            tempH = CFN.CWords(j).rc.nBottom - CFN.CWords(j).rc.nTop
            CFN.CWords(j).rc.nTop = CFN.CWords(j).rc.nTop + (hMax-tempH)/2 + CFN.EdgeMargin
            CFN.CWords(j).rc.nBottom = CFN.CWords(j).rc.nTop + tempH
        End If
    Next i

End Sub

Sub BuildSymbolMenus
    If Debug Then cPrint LCase$(FuncName$)
    Local i,iCount As Long, temp$
    'delete menu items
    For i = 1000 To 1100 : Menu Delete hPopupSymbols, ByCmd i : Next i
    'create menu items
    temp$ = Dir$(Exe.Path$ + "masks\*.bmp")
    For i = 1001 To 1100
       If Len(temp$)= 0 Then Exit For
       Menu Add String, hPopupSymbols, temp$, i, %MF_Enabled
       Incr iCount
       temp$ = Dir$
    Next i
    If iCount = 0 Then Menu Add String, hPopupSymbols, "<no masks found>", 1000, %MF_Enabled
End Sub

Sub CreateGColors(clrHi As Long, clrLo As Long)
    If Debug Then cPrint LCase$(FuncName$)
    'works on CFN.ColorHi, CFN.ColorLo
    Local i,R1,R2,G1,G2,B1,B2 As Long, r As Single
    ReDim GColors(100)
    Graphic Attach hDlg, %IDC_GraphicL, ReDraw
    For i =  0 To 100
        R1 = clrLo Mod 256
        G1 = (clrLo\256) Mod 256
        B1 = (clrLo\256\256) Mod 256
        R2 = clrHi Mod 256
        G2 = (clrHi\256) Mod 256
        B2 = (clrHi\256\256) Mod 256
        r = i / 100
        GColors(i) = RGB( (R1 + (R2-R1)*r), (G1 + (G2-G1)*r), (B1 + (B2-B1)*r) )
        Graphic Set Pixel (0,100-i),GColors(i)
        Graphic Set Pixel (1,100-i),GColors(i)
        Graphic Set Pixel (2,100-i),GColors(i)
        Graphic Set Pixel (3,100-i),GColors(i)
    Next i
    Graphic ReDraw
    Graphic Attach hDlg, %IDC_Graphic
End Sub

Sub SetRandomPositions
    If Debug Then cPrint LCase$(FuncName$)
    Local i,j,gW,gH,w,h,Flag As Long, r As Rect
    Control Get Client hDlg, %IDC_Graphic To gW,gH
    Iterations = 0 : SkipList = "" : qStart = GetTickCount : TimeIsUp = 0

    For i = 1 To CFN.MaxCWords
        MaxLoops = 0 : Continue = 1
        Do
            CFN.CWords(i).rc.nLeft = Rnd(CFN.EdgeMargin,gW)
            CFN.CWords(i).rc.nTop = Rnd(CFN.EdgeMargin,gH)
            If CFN.Rotation And (CFN.CWords(i).rot>4) Then
                    Graphic Set Font FontsRA(CFN.CWords(i).FontSize)
                    Graphic Text Size Trim$(CFN.CWords(i).Text) To w,h
                    CFN.CWords(i).rc.nLeft = Min(CFN.CWords(i).rc.nLeft, gW-h-2*CFN.WordMarginH-CFN.EdgeMargin)   'Edge margin
                    CFN.CWords(i).rc.nTop = Min(CFN.CWords(i).rc.nTop, gH-w-2*CFN.WordMarginV-CFN.EdgeMargin)     'Edge margin
                    CFN.CWords(i).rc.nRight = CFN.CWords(i).rc.nLeft + h + 2*CFN.WordMarginH
                    CFN.CWords(i).rc.nBottom = CFN.CWords(i).rc.nTop + w + 2*CFN.WordMarginV
            Else   'no rotation
                    Graphic Set Font FontsA(CFN.CWords(i).FontSize)
                    Graphic Text Size Trim$(CFN.CWords(i).Text) To w,h
                    CFN.CWords(i).rc.nLeft = Min(CFN.CWords(i).rc.nLeft, gW-w-2*CFN.WordMarginH-CFN.EdgeMargin) 'don't go past right side
                    CFN.CWords(i).rc.nTop = Min(CFN.CWords(i).rc.nTop, gH-h-2*CFN.WordMarginV-CFN.EdgeMargin)  'dont' go past bottom1
                    CFN.CWords(i).rc.nRight = CFN.CWords(i).rc.nLeft + w + 2*CFN.WordMarginH          'size is width of text, no margin added
                    CFN.CWords(i).rc.nBottom = CFN.CWords(i).rc.nTop + h + 2*CFN.WordMarginV          'height is height of text, no margin added
            End If
            Flag = 0   '0=does not overlap   1=overlaps existing word
            For j = 1 To i-1
               If IntersectRect(r,CFN.CWords(i).rc,CFN.CWords(j).rc) Then Flag = 1 : Exit For  'Flag=1 mean overlaps
            Next j
            'decide whether to stop, or continue looping
            Incr MaxLoops : Incr Iterations
            If MaxLoops > MaxIterations Then
               SkipList = SkipList + $CrLf + Trim$(CFN.CWords(i).Text)
               MaxLoops = 0
               Flag = 0   'next iteration of FOR loop - word put on skiplist
               CFN.CWords(i).vis = 0
            End If
            qEnd = GetTickCount
            If (qEnd-qStart)/1000 > MaxTime Then
                TimeIsUp = 1 : Beep
                For j = i To CFN.MaxCWords
                   SkipList = SkipList + $CrLf + Trim$(CFN.CWords(j).Text)
                   CFN.CWords(j).vis = 0
                Next j
                Exit For
            End If
        Loop While Flag And Continue
    Next i
End Sub

Sub SetSymbolPositions
    If Debug Then cPrint LCase$(FuncName$)
    Local i,j,gW,gH,w,h,Flag As Long, r As Rect
    Control Get Client hDlg, %IDC_Graphic To gW,gH
    Iterations = 0 : SkipList = "" : qStart = GetTickCount : TimeIsUp = 0

    For i = 1 To CFN.MaxCWords
        MaxLoops = 0 : Continue = 1
        Do
            CFN.CWords(i).rc.nLeft = Rnd(CFN.Edgemargin,gW)
            CFN.CWords(i).rc.nTop = Rnd(CFN.EdgeMargin,gH)
            If CFN.Rotation And (CFN.CWords(i).rot>4) Then
                    Graphic Set Font FontsRA(CFN.CWords(i).FontSize)
                    Graphic Text Size Trim$(CFN.CWords(i).Text) To w,h
                    CFN.CWords(i).rc.nLeft = Min(CFN.CWords(i).rc.nLeft, gW-h-2*CFN.WordMarginH-CFN.EdgeMargin)   'Edge margin
                    CFN.CWords(i).rc.nTop = Min(CFN.CWords(i).rc.nTop, gH-w-2*CFN.WordMarginV-CFN.EdgeMargin)     'Edge margin
                    CFN.CWords(i).rc.nRight = CFN.CWords(i).rc.nLeft + h + 2*CFN.WordMarginH
                    CFN.CWords(i).rc.nBottom = CFN.CWords(i).rc.nTop + w + 2*CFN.WordMarginV
            Else   'no rotation
                    Graphic Set Font FontsA(CFN.CWords(i).FontSize)
                    Graphic Text Size Trim$(CFN.CWords(i).Text) To w,h
                    CFN.CWords(i).rc.nLeft = Min(CFN.CWords(i).rc.nLeft, gW-w-2*CFN.WordMarginH-CFN.EdgeMargin) 'don't go past right side
                    CFN.CWords(i).rc.nTop = Min(CFN.CWords(i).rc.nTop, gH-h-2*CFN.WordMarginV-CFN.EdgeMargin)  'dont' go past bottom1
                    CFN.CWords(i).rc.nRight = CFN.CWords(i).rc.nLeft + w + 2*CFN.WordMarginH          'size is width of text, no margin added
                    CFN.CWords(i).rc.nBottom = CFN.CWords(i).rc.nTop + h + 2*CFN.WordMarginV          'height is height of text, no margin added
            End If
            Flag = 0   '0=does not overlap and is in symbol
                       '1=overlaps existing word or is outside the symbol
            If InSymbol(CFN.CWords(i).rc) Then
                For j = 1 To i-1
                   If IntersectRect(r,CFN.CWords(i).rc,CFN.CWords(j).rc) Then Flag = 1 : Exit For  'Flag = 1 means overlap or outside the symbol
                Next j
            Else
                Flag = 1   'outside the symbol
             End If
            Incr MaxLoops : Incr Iterations
            If MaxLoops > MaxIterations Then
               SkipList = SkipList + $CrLf + Trim$(CFN.CWords(i).Text)
               Flag = 0   'next iteration of FOR loop - word put on skiplist
               CFN.CWords(i).vis = 0
            End If
            qEnd = GetTickCount
            If (qEnd-qStart)/1000 > MaxTime Then
                TimeIsUp = 1 : Beep
                For j = i To CFN.MaxCWords
                   SkipList = SkipList + $CrLf + Trim$(CFN.CWords(j).Text)
                   CFN.CWords(j).vis = 0
                Next j
                Exit For
            End If
        Loop While Flag And Continue
    Next i
End Sub

Function InSymbol(rc As Rect) As Long
    If Debug Then cPrint LCase$(FuncName$)
    Graphic Attach hSymbol,0
    If Graphic(Pixel, rc.nLeft, rc.nTop) = CFN.MaskColor Then Graphic Attach hDlg, %IDC_Graphic : Exit Function
    If Graphic(Pixel, rc.nLeft, rc.nBottom) = CFN.MaskColor Then Graphic Attach hDlg, %IDC_Graphic : Exit Function
    If Graphic(Pixel, rc.nRight, rc.nTop) = CFN.MaskColor Then Graphic Attach hDlg, %IDC_Graphic : Exit Function
    If Graphic(Pixel, rc.nRight, rc.nBottom) = CFN.MaskColor Then Graphic Attach hDlg, %IDC_Graphic : Exit Function
    Graphic Attach hDlg, %IDC_Graphic
    Function = 1
End Function

Sub LoadSymbol
    If Debug Then cPrint LCase$(FuncName$)
    If IsFile(Trim$(CFN.SymbolName)) Then
        Graphic Bitmap Load CFN.SymbolName, 0, 0 To hSymbol   'takes on natural size of symbol
    Else
        Graphic Bitmap New 100,100 To hSymbol   '100x100 is arbitrary 'creates all black background
    End If
    Graphic Attach hSymbol,0
    Graphic Get Canvas To symW,symH
    Graphic Attach hDlg, %IDC_Graphic
End Sub

Sub SetSymbolScale
    If Debug Then cPrint LCase$(FuncName$)
    Local w,h As Long
    Control Get Client hDlg, %IDC_Graphic To w,h
    Graphic Attach hSymbol,0
    Graphic Scale (0,0)-(w-1,h-1)
    Graphic Attach hDlg, %IDC_Graphic
End Sub

Function WordList() As String
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long, temp$
    For i = 1 To %CWordLimit
        If Len(Trim$(CFN.CWords(i).Text)) Then temp$ = temp$ + $CrLf + Trim$(CFN.CWords(i).Text)
    Next i
    Function = temp$
End Function

Function MergeCWordsV() As String
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, i As Long
    For i = 1 To CFN.MaxCWords
        If CFN.CWords(i).vis Then temp$ = temp$ + $CrLf + Format$(i,"000 ") + Trim$(CFN.CWords(i).Text)
    Next i
    Function = temp$
End Function

Function MergeCWords() As String
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, i As Long
    For i = 1 To CFN.MaxCWords
        temp$ = temp$ + $CrLf + Format$(i,"000 ") + Trim$(CFN.CWords(i).Text)
    Next i
    Function = temp$
End Function

Sub OpenTarget
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, iResult As Long
    temp$ = Trim$(CFN.CWords(CValue).target)
    If Len(temp$) Then
       iResult = ShellExecute(hDlg, "Open", (Trim$(CFN.CWords(CValue).target)), $Nul, $Nul, %SW_ShowNormal)
    Else
       iResult = ShellExecute(hDlg, "Open", (Trim$(CFN.CWords(CValue).Text)), $Nul, $Nul, %SW_ShowNormal)
    End If
    If iresult <= 32 Then Beep  'failed
End Sub

Sub ClearAllTargets
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    For i = 1 To %CWordLimit
        CFN.CWords(i).target = ""
    Next i
End Sub

Function GetDroppedFileName(hDrop As Dword) As String
   If Debug Then cPrint LCase$(FuncName$)
   'David Gwillim July 2005
   Local fString As AsciiZ*%Max_Path, Count As Long
   fString=Space$(%Max_Path)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                           ' put Count chars into result string
End Function

Function GetLinkInfo(LinkPath As String ) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local CLSID_ShellLink, IID_IShellLink As GUIDAPI
   Local CLSCTX_INPROC_SERVER, Flags, lResult As Dword
   Local FileData As WIN32_FIND_DATA
   Local IID_Persist As String * 16, pp, ppf, psl As Dword Ptr
   Local outvalue, TmpAsciiz As AsciiZ * %Max_Path
   Local TmpWide As AsciiZ * ( 2 * %Max_Path )
   Poke$ VarPtr(CLSID_ShellLink), Mkl$( &H00021401 ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   Poke$ VarPtr(IID_IShellLink), Mkl$( &H000214EE ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   IID_Persist = Mkl$( &H0000010B ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   CLSCTX_INPROC_SERVER = 1
   If IsFalse( CoCreateInstance(CLSID_ShellLink, ByVal %NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, psl )) Then
      pp = @psl: Call Dword @pp Using Sub3( ByVal psl, IID_Persist, ppf ) To lResult
      TmpAsciiz = LinkPath
      MultiByteToWideChar %CP_ACP, 0, TmpAsciiz, %Max_Path, ByVal VarPtr(TmpWide), 2 * %Max_Path
      pp = @ppf + 20: Call Dword @pp Using Sub3( ByVal ppf, TmpWide, ByVal %TRUE )
      pp = @psl + 12: Call Dword @pp Using Sub5( ByVal psl, outvalue, ByVal %Max_Path, FileData, Flags )  'GetFilePath
      pp = @ppf + 8: Call Dword @pp Using Sub1( ByVal ppf )      'Release the persistant file
      pp = @psl + 8: Call Dword @pp Using Sub1( ByVal psl )      'Unbind the shell link object from the persistent file
      Function = outvalue
   End If
End Function

Sub MoveWord(D$,iDelta As Long)
    If Debug Then cPrint LCase$(FuncName$)
    Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Moving word: " + CFN.CWords(oldPos).Text
    Select Case D$
        Case "left"  : OffSetRect CFN.CWords(oldPos).rc, -iDelta, 0
        Case "right" : OffSetRect CFN.CWords(oldPos).rc, iDelta, 0
        Case "up"    : OffSetRect CFN.CWords(oldPos).rc, 0, -iDelta
        Case "down"  : OffSetRect CFN.CWords(oldPos).rc, 0, iDelta
    End Select
    RedrawCloud
End Sub

Sub AddWord
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, x,y As Long, pt As Point
    GetCursorPos pt               'pt has xy screen coordinates
    temp$ = InputBox$("Enter new word.","New Word","New",pt.x-100,pt.y-200)
    If Len(temp$) Then
        Incr CFN.MaxCWords
        CFN.CWords(CFN.MaxCWords) = CFN.CWords(CValue)
        CFN.CWords(CFN.MaxCWords).Text = temp$
        ResizeWordBoundary (CFN.MaxCWords)
        OffSetRect CFN.CWords(CFN.MaxCWords).rc, -50,-50
        pt.x = CFN.CWords(CFN.MaxCWords).rc.nLeft + 5
        pt.y = CFN.CWords(CFN.MaxCWords).rc.nTop + 5
        ClientToScreen hGraphic, pt
        SetCursorPos pt.x,pt.y
        RedrawCloud
    End If
End Sub

Sub ResizeWordBoundary(iPos As Long)
    If Debug Then cPrint LCase$(FuncName$)
    Local w,h As Long
    If CFN.Rotation And (CFN.CWords(iPos).rot>4) Then
            Graphic Set Font FontsRA(CFN.CWords(iPos).FontSize)
            Graphic Text Size Trim$(CFN.CWords(iPos).Text) To w,h
            CFN.CWords(iPos).rc.nRight = CFN.CWords(iPos).rc.nLeft + h + 2*CFN.WordMarginH
            CFN.CWords(iPos).rc.nBottom = CFN.CWords(iPos).rc.nTop + w + 2*CFN.WordMarginV
    Else   'no rotation
            Graphic Set Font FontsA(CFN.CWords(iPos).FontSize)
            Graphic Text Size Trim$(CFN.CWords(iPos).Text) To w,h
            CFN.CWords(iPos).rc.nRight = CFN.CWords(iPos).rc.nLeft + w + 2*CFN.WordMarginH          'size is width of text, no margin added
            CFN.CWords(iPos).rc.nBottom = CFN.CWords(iPos).rc.nTop + h + 2*CFN.WordMarginV          'height is height of text, no margin added
    End If
End Sub

Sub AdjustRotation(i As Long, rot As Long)
    If Debug Then cPrint LCase$(FuncName$)
    Local w,h,gW,gH As Long
    CFN.CWords(CValue).rot = rot
    If rot>4 Then
            Graphic Set Font FontsRA(CFN.CWords(i).FontSize)
            Graphic Text Size Trim$(CFN.CWords(i).Text) To w,h
            CFN.CWords(i).rc.nRight = CFN.CWords(i).rc.nLeft + h + 2*CFN.WordMarginH
            CFN.CWords(i).rc.nBottom = CFN.CWords(i).rc.nTop + w + 2*CFN.WordMarginV
    Else   'no rotation
            Graphic Set Font FontsA(CFN.CWords(i).FontSize)
            Graphic Text Size Trim$(CFN.CWords(i).Text) To w,h
            CFN.CWords(i).rc.nRight = CFN.CWords(i).rc.nLeft + w + 2*CFN.WordMarginH          'size is width of text, no margin added
            CFN.CWords(i).rc.nBottom = CFN.CWords(i).rc.nTop + h + 2*CFN.WordMarginV          'height is height of text, no margin added
    End If
End Sub

Sub ClearConsole
   If Debug Then cPrint LCase$(FuncName$)
   Local hWrittenChars As Long, tConsoleInfo As CONSOLE_SCREEN_BUFFER_INFO
   GetConsoleScreenBufferInfo(hConsole, tConsoleInfo)
   FillConsoleOutputCharacter(hConsole, 32, tConsoleInfo.dwSize.x * tConsoleInfo.dwSize.y, Mak(Dword,0,0), hWrittenChars)
   SetConsoleCursorPosition(hConsole, Mak(Dword,0,0))
   Sleep 500   'time for cursor to move off ListView
End Sub
